/*
 * messaging 
 *
 * begin : 21-6-1999 BastardAI
 *
 */

/*
 * INCLUDES
 */
#include <stdlib.h>
#include <glib.h>
#include <iostream> 
#include <map> 
#include <list> 
#include <vector>
#include <string> 
#include <dlfcn.h> 
#include <stdio.h> 
#include <unistd.h> 

#ifndef MAININCLUDE
#define MAININCLUDE


/*
 * DEFINE
 */
#define PACKAGETITLE      "Piper BL ADMINISTRATOR"
#define VERSION_STRING  "0.5.0pre1"
#define DEBUG_MESSAGING 1
#define MAXDLID 65535
#define NUMBERDATAOBJECTS 65535

/* Logging */
#define PIPER_LOG_DOMAIN "Piper"
#define PIPER_BL_LOG_DOMAIN "Piper BL"


/*
 * VARIS
 */
extern gint errno;

#ifndef __freebsd__
extern gint sys_nerr;
#endif

/*
 * ENUMS
 */
enum _nodeType_t {
    SensorNode,       /* Sensors.. those-who-gather-data */
    PipeLineNode,     /* The pipline, a unique MO that has\gets\is\willbe :
                         authentication, all-tree parent (ATP) and encryption
                         as it's processing job */
    CollectorNode,    /* Collector's are 2nd leven authentication, are
                         mayor-tree parents (MTP), they are gates to
                         subsystems (that are defined by functionality) */
    FilterNode,        /* Filters, regulair NN members */
    VisualNode,        /* The-End's. They're the last member(s) of all trees */
    VisualCentralNode, /* special visual that links all visuals */
    TemporaryNode,     /* Temporary MO, used for caching\linking */
    UnknownNode        /* Unknown, error? */
}; typedef enum _nodeType_t nodeType_t;


enum _statusType_t {
    Passing,    /* Node accepts data */
    Blocking,   /* Node does not accept data */
    //removed, ??, NonStream    /* used for temporary MOs */
    Unknown     /* Unknown status, error? */
}; typedef enum _statusType_t statusType_t;


enum _formatType_t {
    String,     /* String data (text) */
    Integer,    /* Numeric data */
    Percentage, /* Percentage data (0-100) */
    Boolean,    /* Boolean data (TRUE/FALSE) */
    Unique      /* Raw data */
}; typedef enum _formatType_t formatType_t;


enum _rType_t {
    NoneRT,
    SameRT,
    RedefineRT,
    Undefined_StructRT,
    Sequential_StructRT,
    DualSequential_StructRT,
    ChainEnd_StructRT
}; typedef enum _rType_t rType_t;

typedef struct _plugin_maker plugin_maker;
struct _plugin_maker {
    gboolean (*procedure)();
    gboolean (*cleanup)();
    gboolean (*activate)();
    gboolean (*init)(glong,gpointer);
    const gchar* (*name)();
    const gchar* (*description)();
    nodeType_t (*nodetype)();
};

/* Plugin list */
 typedef plugin_maker* maker_ptr();
 extern map <string, maker_ptr*,less<string> > BL_plugins;

/* STRUCTS
 */
typedef struct _messaging_area_DL messaging_security_DL;
struct _messaging_area_DL {
    gint DLid;             /* Id of DL */
    GString *password;     /* password */
    gboolean MasterDLid;   /* Id of DL that created this area */
    GList *nodes;          /* node id's that belong to this area */
};

#endif
