/*
 *
 */

#ifndef ADMIN
#define ADMIN

#include <fstream.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <fcntl.h>
#include <unistd.h>
#include "messaging_engine.h"
#include <ADMDFP.hh>

/*
 * ADMDFP_i
 */
class ADMDFP_i : public POA_admin2bl::ADMDFP,
                 public PortableServer::RefCountServantBase {
public:
        inline ADMDFP_i() {
            /* init variables */
            CLIENT_ID = MAXDLID - 1;
            CLIENT_PASSWORD = (gchar*)"ADM";
            Engine = new engine();
        }
	virtual ~ADMDFP_i() {}

	virtual CORBA::Boolean dbSAVEstate(CORBA::Long DLid, const char* Password);
	virtual CORBA::Boolean dbLOADstate(CORBA::Long DLid, const char* Password);
	virtual CORBA::Boolean dbDESTRUCTstate(CORBA::Long DLid, const char* Password);
	virtual CORBA::Boolean dbMATCHregexp(const gchar* ST1, const gchar* ST2,CORBA::Long DLid, const char* Password);
	virtual CORBA::Long dbRELATEbyname(const gchar* searchstring, glong Node,CORBA::Long DLid, const char* Password);
	virtual CORBA::Long dbRELEASEbyname(const gchar* searchstring, glong Node,CORBA::Long DLid, const char* Password);
	virtual CORBA::Long dbRELATEbyfilter(const gchar* searchstring, glong Node,CORBA::Long DLid, const char* Password);
	virtual CORBA::Long dbRELATEbymo(glong NodeP,glong NodeC,CORBA::Long DLid, const char* Password);

	virtual CORBA::Boolean dbSETpipeline(glong Node);
	virtual CORBA::Boolean dbREGISTERadm(glong clientID);
	virtual CORBA::Boolean dbUNREGISTERadm(glong clientID);
	virtual CORBA::Boolean dbLOADplugins();
	virtual CORBA::Boolean dbREGISTERvisualpanels();
	virtual void dbDEADENDDIALOGclosed();

	virtual CORBA::Long mobjectNEW(const gchar* dname,const gchar* description,glong nodetype,glong init);
	virtual CORBA::Boolean mobjectDESTRUCT(glong Node);
	virtual CORBA::Boolean mobjectDESTRUCTplug(glong Node);
	virtual CORBA::Long mobjectCALLinit(glong Node);
	virtual CORBA::Long mobjectCALLdestruct(glong Node);
	virtual CORBA::Long mobjectCALLconfigplugbuildprocedure(glong Node,glong XID);

	virtual gchar* mobjectGETCHARallowedfilter(glong Node);
	virtual gchar* mobjectGETCHARnodetype(glong Node);
	virtual gchar* mobjectGETCHARrtype(glong Node);
	virtual gchar* mobjectGETCHARstatus(glong Node);

	virtual CORBA::Long mobjectGETrelation(glong Node,glong relation);
	virtual gchar* mobjectGETdname(glong Node);
	virtual gchar* mobjectGETdescription(glong Node);
	virtual gchar* mobjectGETallowedfilter(glong Node);
	virtual gchar* mobjectGETdatadescription(glong Node);
	virtual CORBA::Long mobjectGETname(glong Node);
	virtual CORBA::Long mobjectGETnodetype(glong Node);
    virtual CORBA::Long mobjectGETstatus(glong Node);
    virtual CORBA::Long mobjectGETcurrentrelations(glong Node);
    virtual CORBA::Long mobjectGETvisualsocket(glong Node);
    virtual CORBA::Long mobjectGETconfigplugbuildprocedure(glong Node);
    virtual gchar* mobjectGETconfigruntime(glong Node);
    virtual CORBA::Long mobjectGETrawdatalen(glong Node);
    virtual CORBA::Long mobjectGETdata(glong Node);
    virtual CORBA::Long mobjectGETplug(glong Node);
    virtual CORBA::Long mobjectGETnrObjects();
	virtual CORBA::Long mobjectGETnthObjectREF(glong NR);

	virtual CORBA::Boolean mobjectSETstatus(glong Node,glong status);
	virtual CORBA::Boolean mobjectSETconfigplug(glong Node,glong configplug);
	virtual CORBA::Boolean mobjectSETvisualplug(glong Node,glong visualplug);
	virtual CORBA::Boolean mobjectSETconfigruntime(glong Node,const gchar* runtime);
	virtual CORBA::Boolean mobjectSETdname(glong Node,const gchar* text);
	virtual CORBA::Boolean mobjectSETdescription(glong Node,const gchar* text);
	virtual CORBA::Boolean mobjectSETdatadescription(glong Node,const gchar* text);
    virtual CORBA::Boolean mobjectSETdatapassedover(glong Node,CORBA::Boolean state);
	virtual CORBA::Boolean mobjectSETprocedure(glong Node,glong procedure);
	virtual CORBA::Boolean mobjectSETnodetype(glong Node,glong nodetype);
	virtual CORBA::Boolean mobjectSETinit(glong Node,glong init);
	virtual CORBA::Boolean mobjectSETdestruct(glong Node,glong destruct);
	virtual CORBA::Boolean mobjectSETallowedfilter(glong Node,const gchar* filter);

	virtual CORBA::Long dataobjectNEW(glong Node,glong rawmemlen);
	virtual CORBA::Boolean dataobjectDESTRUCT(glong MDO);
	virtual CORBA::Boolean dataobjectDUPLICATE(glong MDOD,glong MDOS);
	virtual gchar* dataobjectGETCHARrawdata(glong MDO);
	virtual CORBA::Long dataobjectGETrawdatalen(glong MDO);
	virtual gchar* dataobjectGETstring(glong MDO);
	virtual CORBA::Long dataobjectGETinteger(glong MDO);
	virtual CORBA::Long dataobjectGETpercentage(glong MDO);
	virtual CORBA::Boolean dataobjectGETboolean(glong MDO);
	virtual CORBA::Boolean dataobjectSETrawdata(glong MDO,const gchar* data,glong len);

        /* variables */
        glong CLIENT_ID;
        gchar* CLIENT_PASSWORD;
        engine* Engine; 
};

/*
 * admin
 */
class admin: public ADMDFP_i {
    public:
        inline admin() {
            /* setup the server for the ADM->DFP corba communications */
            /* PIPER NOTE: setup the server for the DL->BL corba communications */
            GString* iorFile;
            gint dummy_argc = 1;
            gchar *dummy_argv[1];
            /* build dummy args */
            dummy_argc = 1;
            dummy_argv[0] = (gchar*)"BL";
            try {
                // start up the ORB and POA
                CORBA::ORB_var orb = CORBA::ORB_init(dummy_argc, dummy_argv, "omniORB3");
                CORBA::Object_var obj = orb->resolve_initial_references("RootPOA");
                PortableServer::POA_var poa = PortableServer::POA::_narrow(obj);
                // get our object to serve out and activate it
                ADMDFP_i* mainConn = new ADMDFP_i();
                PortableServer::ObjectId_var mainConnId = poa->activate_object(mainConn);
                // get an object reference and write the IOR to a file
                CORBA::Object_var objRef = mainConn->_this();
                CORBA::String_var stringIor(orb->object_to_string(objRef));
                /* define IOR file location */
                iorFile = g_string_new(getenv("HOME"));
                iorFile = g_string_append(iorFile, "/piper_info");
                mkdir(iorFile->str,S_IRWXU);
                iorFile = g_string_append(iorFile, "/ior");
                mkdir(iorFile->str,S_IRWXU);
                iorFile = g_string_append(iorFile, "/admin2bl.ior");
                ofstream outStream;
                outStream.open(iorFile->str);
                outStream << stringIor;
                outStream.close();
                // only the POA holds a reference to the connection interface now
                mainConn->_remove_ref();
                // Activate the POA manager and run the orb
                PortableServer::POAManager_var pMan = poa->the_POAManager();
                pMan->activate();
                orb->run();
                orb->destroy();
            }
            catch(CORBA::SystemException&) {
                cerr << "Caught a CORBA::SystemException." << endl;
            }
            catch(CORBA::Exception&) {
                cerr << "Caught a CORBA::Exception." << endl;
            }
            catch(omniORB::fatalException& fe) {
                  cerr << "Caught an omniORB::fatalExecption:" << endl;
                  cerr << "  file: " << fe.file() << endl;
                  cerr << "  line: " << fe.line() << endl;
                  cerr << "  mseg: " << fe.errmsg() << endl;
            }
            catch(...) {
                cerr << "Caught an unknown exception." << endl;
            }
            return;
        }
        virtual ~admin() {}

        /* variables */

        /* functionality */
};

#endif
