#include <glib.h>
#include "DL2BL.hh"
#include "messaging_resource.h"

/* 
 * Inheritance overview:
 * TODO
 * area   <- Current Code
 *
 */

#ifndef AREA
#define AREA

class area: private resource {
public:
    inline area() {
        return;
    }
    virtual ~area() {};

    /*
     * Functionality
     */

    /* security */
    gboolean authorized_dl(glong DLid,gchar* Password);
    gboolean authorized_dl_node(glong DLid,gchar* Password,glong Node);
    gboolean authorized_dl_data(glong DLid,gchar* Password,glong Data);
    gboolean secure_node_allowes_data(glong Node,glong Data,glong DLid,gchar* Password);
    gboolean register_node_check_regulair(node* Node);
    gboolean register_node_check_refs(node* Node);
    gboolean secure_register_node(glong Node,glong DLid, gchar* Password);
    gboolean secure_idle(glong delay,glong DLid, gchar* Password);
    glong secure_historyIO_write(glong Node,glong DLid, gchar* Password);
    /* area management */
    gboolean secure_register_dl(glong dlID,gchar *password,glong mdlID,gchar *password_area);
    gboolean secure_unregister_dl(glong dlID,gchar *password);
    gboolean secure_setup_nodes(glong dlID,gchar *password,gpointer Engine);

    /* Locking */
    void secure_lock(const gchar *text,glong DLid,gchar* Password);
    void secure_unlock(const gchar *text,glong DLid,gchar* Password);
    void secure_locknunlock(const gchar *text,glong DLid,gchar* Password);

    /* data access */
    glong secure_data_new(glong Data,glong rawmemlen,glong DLid,gchar* Password);
    glong secure_data_new(glong Data,glong DLid,gchar* Password);
    gboolean secure_data_delete(const glong data,glong DLid,gchar* Password);
    gboolean secure_typecast(glong data, glong DLid, gchar* Password);

    /* node access */
    glong secure_node_new(gchar *dname,gchar *ddescription, gchar *allowedfilter, nodeType_t type,gpointer init_ref,gpointer procedure_ref,gpointer cleanup_ref, gpointer activate_ref,glong DLid,gchar* Password);
    gboolean secure_node_delete(const glong node,glong DLid,gchar* Password);
    glong secure_node_cloon(glong Node,glong DLid,gchar* Password);
    gboolean secure_node_add_relation(glong node,glong relation,glong DLid,gchar* Password);

    /* Node get's */
    glong secure_node_get_name(glong node,glong DLid,gchar* Password);
    GString* secure_node_get_dname(glong node,glong DLid,gchar* Password);
    GString* secure_node_get_description(glong node,glong DLid,gchar* Password);
    nodeType_t secure_node_get_nodetype(glong node,glong DLid,gchar* Password);
    gpointer secure_node_get_procedure(glong node,glong DLid,gchar* Password);
    statusType_t secure_node_get_status(glong node,glong DLid,gchar* Password);
    GString* secure_node_get_allowedfilter(glong Node,glong DLid,gchar* Password);
    GString* secure_node_get_datadescription(glong node,glong DLid,gchar* Password);
    glong secure_node_get_relation(glong node,glong relation,glong DLid,gchar* Password);
    glong secure_node_get_currentrelations(glong node,glong DLid,gchar* Password);
    glong secure_node_get_data(glong node,glong DLid,gchar* Password);
    glong secure_node_get_childs(glong node,glong DLid,gchar* Password);
    glong secure_node_get_nth_child(glong node,glong child,glong DLid,gchar* Password);
    gboolean secure_node_get_datapassedover(glong node,glong DLid,gchar* Password);
    glong secure_nodes(glong DLid,gchar* Password); /* return number of availeble nodes */
    gboolean secure_node_get_procedure_handled(glong node,glong DLid,gchar* Password);
    gboolean secure_node_get_procedure_running(glong node,glong DLid,gchar* Password);
    gpointer secure_node_get_visualplug_buildprocedure(glong node,glong DLid,gchar* Password);
    GString* secure_node_get_configinit(glong node,glong DLid,gchar* Password);
    GString* secure_node_get_configruntime(glong node,glong DLid,gchar* Password);
    uriS* secure_node_get_uri(glong Node,glong DLid,gchar* Password);

    /* Data get's */
    glong secure_data_get_id(glong data,glong DLid,gchar* Password);
    GString* secure_data_get_datadescription(glong data,glong DLid,gchar* Password);
    gchar* secure_data_get_rawdata(glong data,glong DLid,gchar* Password);
    glong secure_data_get_rawlen(glong data,glong DLid,gchar* Password);
    GString* secure_data_get_string(glong data,glong DLid,gchar* Password);
    gint secure_data_get_integer(glong data,glong DLid,gchar* Password);
    gint secure_data_get_percentage(glong data,glong DLid,gchar* Password);
    gboolean secure_data_get_boolean(glong data,glong DLid,gchar* Password);

    /* Node set's */
    gboolean secure_node_set_dname(glong node,gchar* dname,glong DLid,gchar* Password);
    gboolean secure_node_set_status(glong node,statusType_t status,glong DLid,gchar* Password);
    gboolean secure_node_set_description(glong node,gchar* text,glong DLid,gchar* Password);
    gboolean secure_node_set_datadescription(glong node,gchar* text,glong DLid,gchar* Password);
    gboolean secure_node_set_nodetype(glong node,nodeType_t nodetype,glong DLid,gchar* Password);
    gboolean secure_node_set_allowedfilter(glong node,gchar* filter,glong DLid,gchar* Password);
    gboolean secure_node_set_procedure_handled(glong node,gboolean handled,glong DLid,gchar* Password);
    gboolean secure_node_set_procedure_running(glong node,gboolean running,glong DLid,gchar* Password);
    gboolean secure_node_set_datapassedover(glong node,gboolean passed,glong DLid,gchar* Password);
    gboolean secure_node_set_uisetup(glong node,gboolean uisetup,glong DLid,gchar* Password);
    gboolean secure_node_set_configinit(glong Node,gchar* config,glong DLid,gchar* Password);
    gboolean secure_node_set_configruntime(glong Node,gchar* config,glong DLid,gchar* Password);
    gboolean secure_data_set_originatorID(glong Data,glong ID,glong DLid,gchar* Password);

 
    /* Node various */
    gboolean secure_node_add_blockedlist(glong node,glong data,glong DLid,gchar* Password);
    gboolean secure_node_execute_procedure(glong node,glong DLid,gchar* Password);
    gboolean secure_node_execute_visualplug_buildprocedure(glong Node,glong XID,glong DLid,gchar* Password);
    gboolean secure_conflictportal(glong,glong,rType_t,glong DLid, gchar* Password);
    gboolean secure_deadend(glong Node,glong DLid, gchar* Password);

    /* Data set's */
    gboolean secure_data_set_datadescription(glong data,gchar* datadescription,glong DLid,gchar* Password);
    gboolean secure_data_set_rawdata(glong data,gchar* rawdata,gint len,glong DLid,gchar* Password);
    gboolean secure_data_clean_rawdata(glong data,glong DLid,gchar* Password);

    /* data access */
    gboolean secure_data_copy(glong data,glong source,glong DLid,gchar* Password);
    gboolean secure_data_clear(glong data,glong DLid,gchar* Password);

    /* lookup lists access */
    glong secure_node_lookup_by_dname(gchar* dname,glong DLid,gchar* Password);
    glong secure_node_lookup_by_filter(gchar* Filter,glong DLid,gchar* Password);

    /* relations */
    gboolean secure_relate_node_to_node(glong parent_node,glong child_node,glong DLid,gchar* Password);
    gboolean secure_relate_dname_to_dname(gchar* parent,gchar* child,glong DLid,gchar* Password);
    gboolean secure_relate_node_to_dname(glong parent,gchar* dname,glong DLid,gchar* Password);
    gboolean secure_unrelate_node_to_node(glong parent_node,glong child_node,glong DLid,gchar* Password);


    /*
     * Variables
     */
    static const gint AREA_LOCAL = 0;
    static const gint AREA_REMOTE = 1;

    /* 
     * Private's
     */
};


#endif

