/*
 */

#ifndef DATA
#define DATA

#include <glib.h>
#include "messaging.h"
#include "DL2BL.hh"

#define DATA_RAWLEN 8192

class data {
    public:
        inline data() {
            /* set dataDescription */
            datadescription = g_string_new("");
            /* allocate rawdata */
            rawdata = (gchar*)g_malloc(DATA_RAWLEN);
            /* allocate String */
            string = g_string_new("");
            typecast(this);
        };
        inline data(gchar* DataDescription,guint RawDataLen) {
            /* set dataDescription */
            datadescription = g_string_new(DataDescription);
            /* set rawdataLen */
            if (RawDataLen == 0) {
                RawDataLen = DATA_RAWLEN;
            } else {
                rawdatalen = RawDataLen;
            }
            /* allocate rawdata */
            rawdata = (gchar*)g_malloc(RawDataLen);
            /* allocate String */
            string = g_string_new("");
            /* Set originator ID to nothing */
            originatorID = 0;
            typecast(this);
        };
        virtual ~data() {
            /* free MDO + GString inside it */
            g_string_free(string,TRUE);
            g_string_free(datadescription,TRUE);
            g_free(rawdata);
            return;
        };


        /* varis */
        glong    ID;                 /* ID of data block */
        glong    originatorID;       /* NodeID of originating sensor */
        GString  *datadescription;   /* Description of data block */
        gchar    *rawdata;           /* raw data, main data field */
        guint    rawdatalen;         /* length of rawdata memory block */
        GString  *string;            /* string data representation */
                                     /* TODO: String -> non-pointer */
        gint     integer;            /* Integer data representation */
        gint     percentage;         /* Percentage data representation */
        gboolean boolean;            /* Boolean data representation */


        /* functionality */
        gboolean typecast(data* Data);
        gboolean data_copy(data *Destination,data *Source);

};

#endif

