/*
 * kapi_unregister.c -- removes an url entry to the agent record
 *
 * Copyright (c)  1993, 1994 Enterprise Integration Technologies Corporation
 * and Lockheed Missiles and Space Company, Inc.
 *
 * Permission to use, copy, modify, distribute, and sell this software and 
 * its documentation for any purpose is hereby granted without fee, provided
 * that (i) the above copyright notices and this permission notice appear in
 * all copies of the software and related documentation, and (ii) the name of
 * Enterprise Integration Technologies Corporation and Lockheed Missiles
 * and Space Company may not be used in any advertising or publicity
 * relating to the software without the specific, prior written permission
 * of Enterprise Integration Technologies Corporation and Lockheed Missiles
 * and Space Company.
 * 
 * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
 * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
 *
 * IN NO EVENT SHALL ENTERPRISE INTEGRATION TECHNOLOGIES CORPORATION OR
 * LOCKHEED MISSILES AND SPACE COMPANY BE LIABLE FOR ANY SPECIAL,
 * INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND, OR ANY
 * DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY
 * THEORY OF LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
 * PERFORMANCE OF THIS SOFTWARE.
 *
 */

#include <stdio.h>
#include <string.h>

#define SERVER_DOCROOT "/usr2/home2/olsen/httpd/httpd_1.1/htdocs/agent"

main(argc, argv)
     int argc;
     char *argv[];
{
  FILE *f;

  char *p, *args, *docroot;
  char agentname[1024], aname[256], url[256], buf[1024], buffer[1024],
       line[1024];
  int found;

  args = (char *) getenv("QUERY_STRING");
  docroot = (char *) getenv("SERVER_DOCROOT");

  printf("Content-type: text/html\n\n");

  if (!args[0])
    {
      printf("No QUERY_STRING\n");
      exit(1);
    }

  strcpy(buf, args);

  /* Parse the encoded QUERY_STRING */
  p = strtok(buf, "=");
  strcpy(aname, p);

  p = strtok(NULL, "\n");
  strcpy(url, p);

  /* Create the path to the document root */
  if (docroot)
    strcpy(agentname, docroot);
  else
    strcpy(agentname, SERVER_DOCROOT);

  strcat(agentname, "/");
  strcat(agentname, aname);

  strcpy(buffer, "");

  /* Read in the agent's configuration file. */
  f = fopen(agentname, "r");
  if (f) {
    while (!feof(f)) {
      fgets(line, 1024, f);
      strcat(buffer, line);
      bzero(line, sizeof(line));
    }

    fclose(f);
  }

  /* Check if the entry exists in the configuration file. */
  strcpy(buf, buffer);
  
  strcpy(buffer, "");

  found = 0;
  p = strtok(buf, "\n");
  while (p) {
    if (strcasecmp(p, url) != 0) {
      strcat(buffer, p);
      strcat(buffer, "\n");
    }
    else found = 1;

    p = strtok(NULL, "\n");
  }

  f = fopen(agentname, "w");

  if (f) {
    fputs(buffer, f);
    fclose(f);
  }

  if (found)
    printf("%s\n", url);
  else
    printf("\n");

  return 1;
}
