/*
 *
 *  int.int - Interpreter Interface.
 *  
 *  Interpreter commands.
 *
 *
 *
 */

:- dynamic who_am_i/1.

step :- write('agent-K>'),get_line(X),
        break(X),step.

break(X) :- 
            ((name(What,X),integer(What));
             (name('',X),What='');
            (((member(46,X),X=Y);append(X,".",Y)),
            read(What) from_chars Y)), 
            (agent(What);call(What);true).

:- dynamic agent/1.

agent([File])  :- [File].
agent('')      :- (who_am_i(_),go(1)); (write('LOAD AGENT FIRST!'),nl).  
agent(start)   :- step.
agent(stop)    :- halt.
agent(debug)   :- agent_debug.
agent(nodebug) :- nodebug.
agent(log)     :- agent_log.
agent(nolog)   :- agent_nolog.
agent(state)   :- agent_state.
agent(N)       :- integer(N),
                 ((who_am_i(_),go(N)); (write('LOAD AGENT FIRST!'),nl)).
agent(menu)    :- bagof([Menu,Comment],agent(Menu,Comment),Help),printout(Help).
agent(Y)       :- agent([Y]).
agent(Y)       :- write('Error - no command: '),write(Y),nl.

printout([[M,C]|T]) :- write(M),write(' - '),write(C),nl,printout(T).
printout([]) :- nl.

agent('Command','Meaning').
agent('- - - -','- - - -').
agent('<CR>','Step').  
agent(start,'Usage: agent(start), starts interpreter'). 
agent(stop,'Halts interpreter') .
agent('no|debug','Turn on/off spy for key predicates').
agent('no|log','Turn on/off basic logging information'). 
agent('[name]','Load an agent (can also use just name as long as no clash)'). 
agent(state,'Internal beliefs etc of an agent').
agent(n,'Step n seconds').
agent(menu,'This listing').
