/*
 *
 * int.log - for debugging agent programs etc.
 *
 */

:- ensure_loaded(library(fromonto)).

log(Term) :- portray_clause(Term) onto_chars String,
             output_wo_nl(String).

lognl(Term) :- portray_clause(Term).

output_wo_nl([]) :- !.
output_wo_nl([10|Rest]) :- output_wo_nl(Rest), !.
output_wo_nl([H|Rest]) :- put(H), output_wo_nl(Rest),!.

:- dynamic agent_log_flag/0.

agent_log :- assert(agent_log_flag).
agent_nolog :- retract(agent_log_flag).

dlognl(Term) :- agent_log_flag,lognl(Term).
dlognl(_).

dlog(Term) :- agent_log_flag,log(Term).
dlog(_).


dwrite(Term) :- agent_log_flag,write(Term).
dwrite(_).

dnl :- agent_log_flag,nl.
dnl.

agent_debug :- 
   	       	spy(add_belief),
               	spy(read_messages),
               	spy(send_message),
   		spy(cycle),
		spy(execute),
   		spy(process_messages),
   		spy(process_one_message),
   		spy(message_match),
   		spy(process_mental_cond),
   		spy(make_commitment),
   		spy(check_one_commitment),
   		spy(can),
   		spy(refrain),
   		spy(clock),
   		leash([call]),
   		debug.     

agent_state :- 
listing(who_am_i),
listing(addrMap),
listing(what_time_is_it),
listing(can),
listing(b),
listing(cmt),
listing(refrain).

linedash :- dnl,dwrite('-------------------------------------------------------------------------------'),dnl.

line :-  dnl,dwrite('++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++'),dnl.
