/*   Agent0 Intepreter
 *   File #3 :
 *   Message Handler / Comm's Initialise.
 *
 *   Modified to handle KQML Messages instead.
 *
 */


:- dynamic who_ami_i/1, agent_trace/1.

initialise_agent(URL) :-      who_am_i(Name),
	                      ksetupnourl(Name,0,0,StatusSetUp),
		 	      kstatus(StatusSetUp,S1),
			      lognl(['SetUp:',S1]),
                              klisten(URL,StatusListen),
			      kstatus(StatusListen,S2),
			      lognl(['Listen:',S2]).

add_friend(Name,URL) :- kcacheurl(Name,URL,Status),
			kstatus(Status,S1),
		        lognl(['Friend:',Name,URL,'Status:',S1]),nl,
	                what_time_is_it(Now),
		        who_am_i(Me),
                        add_belief(Me,[Now,friend(Name)]).

read_messages([Prolog_Message|Others]) :-
         kbuffer_addr(BufferAddr),
	 kstatus(K_OK,k_ok),
	 kgetstring(BufferAddr,K_OK),
	 kbuffer_str(BufferStr),
	 kqml_prolog(BufferStr,Prolog_Message),
	 read_messages(Others).

read_messages([]).

/*
         kbuffer_addr(BufferAddr),
	 kgetstring(BufferAddr,Status),
	 kstatus(Status,S1),
         lognl(['Read Message Status',S1]).         
*/

send_message(Prolog_Message):-
        kqml_prolog(KQMLMessage,Prolog_Message),
	ksendstring(KQMLMessage,Status),
	kstatus(Status,S1),
	(S1 = k_ok ; 
        lognl(['Failure to send:',Prolog_Message,',Status:',S1])).


