/*
 * kapi.pl - Basic KAPI foreign interface.
 * 
 * (c) Winton Davies, Univeristy of Aberdeen, 1994
 *
 * KNOWN RESTRICTIONS:
 * 
 * requires Sun 0/S (4.2BSD) Quintus Prolog. Maybe works with Sictus.
 * Requires libkapi.a and all the object files to be around
 * Setup LD_LIBRARY_PATH to include libkapi.
 * 
 * VERY BAD HACK: When functions require a buffer and return an address
 * you have to provide an input atom. e.g. kgetstring(mb,MessageBuffer).
 *
 * Slightly non-standard KAPI - split ksetup into two forms in order
 * to be able to pass NULL to KSetUp These are ksetupnourl and ksetupurl.
 *
 * DOES NOT WORK AT ALL ON SOLARIS STILL.
 * 
 * HAVE NOT TESTED THE ANS functions (our HTTP is on Solaris....)
 * 

Connection Functions:

extern char* KPrologMessageBuffer();

extern int KSetUp P((char *, char *, int));  
extern int KInit();
extern int KSetDefaultANS(char *ansurl);
extern int KListen P((char *url));
extern int KDisconnect P(());
extern int KCacheURL P((char *agent, char *url));
extern int KUnCacheURL P((char *agent char *url));
extern int KGetOpenFd(int first);

ANS functions:
extern int KRegister P((char *, char *, char *));
extern int KUnRegister P((char *, char *, char *));
extern int KLookup P((char *, char *, char *));

Get Functions:
extern int KPeek();
extern int KGetString P((char *));
extern int KGetString_or_Wait P((char *));

Send Function:
extern int KSendString P((char *));     

Parse Function: NOT USED in Prolog:
   extern int KParse P((char *, char **, KeydPair *, KeyList **));


*/


/* Where the functions can be found */


foreign_file('kaProlog.o',['KPrologMessageBufferAddr','KPrologMessageBufferStr']).
foreign_file('kaConnect.o',['KInit','KSetUp','KListen','KSetDefaultANS','KDisconnect','KCacheURL','KUnCacheURL','KGetOpenFd']).
foreign_file('kaANS.o',['KRegister','KUnRegister','KLookup']).
foreign_file('kaGet.o',['KGetString','KGetString_or_Wait','KPeek']).
foreign_file('kaSend.o',['KSendString']).
/* foreign_file('kaParse.o',['KGetField','KSetField','KParse']). */

/* function mappings - appears to prefer Prolog atoms as input strings.*/

foreign('KPrologMessageBufferAddr',c,kbuffer_addr([-address(string)])).
foreign('KPrologMessageBufferStr',c,kbuffer_str([-string])).
foreign('KSetUp',c,ksetupnourl(+string,+address(string),+integer,[-integer])).
foreign('KSetUp',c,ksetupurl(+string,+string,+integer,[-integer])).
foreign('KListen',c,klisten(+string,[-integer])).
foreign('KDisconnect',c,kdisconnect([-integer])).
foreign('KInit',c,kinit([-integer])).
foreign('KGetOpenFd',c,kgetopenfd(+integer,[-integer])).
foreign('KSetDefaultANS',c,ksetdefaultans(+string,[-integer])).

foreign('KCacheURL',c,kcacheurl(+string,+string,[-integer])).
foreign('KUnCacheURL',c,kuncacheurl(+string,+string,[-integer])).

foreign('KRegister',c,kregister(+string,+string,+integer,[-integer])).
foreign('KUnRegister',c,kunregister(+string,+string,+integer,[-integer])).
foreign('KLookup',c,lookup(+string,+string,+address(string),[-string])).

foreign('KGetString',c,kgetstring(+address(string),[-integer])).
foreign('KGetString_or_Wait',c,kgetstring_or_wait(+address(string),[-integer])).
foreign('KPeek',c,kpeek([-integer])).


foreign('KSendString',c,ksendstring(+string,[-integer])).

kstatus(0,k_ok).
kstatus(1,k_bad_kqml).
kstatus(2,k_no_ans_response).
kstatus(3,k_bad_url).
kstatus(4,k_no_sender).
kstatus(5,k_no_receiver).
kstatus(6,k_no_transport).
kstatus(7,k_no_msg).
kstatus(8,k_no_field).
kstatus(9,k_no_active_url).
kstatus(-1,k_error).

/* Load the kapi interface. */
:- 
load_foreign_files(['kaProlog.o','kaConnect.o','kaANS.o','kaGet.o','kaSend.o'],['-lkapi']),
write('	Loaded KAPI interface'),nl.






