/*
 * client.c -- example KAPI program
 *
 * Copyright (c)  1993, 1994 Enterprise Integration Technologies Corporation
 * and Lockheed Missiles and Space Company, Inc.
 *
 * Permission to use, copy, modify, distribute, and sell this software and 
 * its documentation for any purpose is hereby granted without fee, provided
 * that (i) the above copyright notices and this permission notice appear in
 * all copies of the software and related documentation, and (ii) the name of
 * Enterprise Integration Technologies Corporation and Lockheed Missiles
 * and Space Company may not be used in any advertising or publicity
 * relating to the software without the specific, prior written permission
 * of Enterprise Integration Technologies Corporation and Lockheed Missiles
 * and Space Company.
 * 
 * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
 * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
 *
 * IN NO EVENT SHALL ENTERPRISE INTEGRATION TECHNOLOGIES CORPORATION OR
 * LOCKHEED MISSILES AND SPACE COMPANY BE LIABLE FOR ANY SPECIAL,
 * INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND, OR ANY
 * DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY
 * THEORY OF LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
 * PERFORMANCE OF THIS SOFTWARE.
 *
 */

#include	<stdio.h>
#include	<string.h>
#include	<kapi.h>
#include        <example-setup.h>

#define         AGENTNAME       "client"
#define         AGENT_URL       CLIENT_URL

int main(argc, argv)
     int	argc;
     char	*argv[];
{
  char	msg_buf[K_MAX_MESSAGE_SIZE], ans[2];
  int msg_no=0;
  int result = 0;
  
  
  KSetUp(AGENTNAME, NULL, 0);
  KCacheURL("server1", SERVER1_URL);
  KCacheURL("server2", SERVER2_URL);
  KCacheURL("server3", SERVER3_URL);

  result = KListen(AGENT_URL);
  if (result != K_OK) {
    fprintf(stderr,"KListen failure, error = %i\n",result);
    exit(0);
  }

  printf("\n ************ %s ************\n", argv[0]);
  printf("\n Make sure a server is running too!\n");
  

  /* Loop to send and receive messages */
  ans[0] = 'y';
  while (ans[0] == 'y') {
    
    printf("\nMake sure to include:\n");
    printf("   :receiver <destination> (server1, server2, server3 or URL)\n");
    printf("   :sender client\n");
    printf("in the message.\n");

    printf("\nEnter message to send: ");
    gets(msg_buf);
    
    /* send message to message bus */
    if (KSendString(msg_buf) != K_OK) {
      printf("Error: cannot send message to destination.\n");
      exit(0); 
    } 
    
    /* get reply */
    if (KGetString_or_Wait(msg_buf) == K_OK) 
      printf("\nMessage received: %s\n\n", msg_buf);
    
    printf("\nAny more messages to send ? (y/n) ");
    gets(ans);

    printf("\n =============== %d ===============\n", ++msg_no);
  }
  
  KDisconnect();
}

