/*===[ bot.c ]================================================================
code copied by bastardAI 4-9-1999
fixed and partially rewritten 

  Bot v0.01 
  11/7/91 - Peyote Coyote 
  
  Generic bot shell.
============================================================================*/
#define __x86__

#include "messaging.h"
#include "messaging_mobject_structs.h"
#include "messaging_mobject_api.h"
#include "messaging_db.h"
#include <gtk/gtk.h>
#include <gmodule.h>
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <ctype.h>
#include "plugin_sensor_irc.h"

#define PLUGIN_IRC_NAME "IRC plugin"
#define PLUGIN_IRC_NAME_SENSOR "IRC plugin sensor"
#define PLUGIN_IRC_NAME_COLLECTOR "IRC plugin collector"
#define PLUGIN_IRC_DESCRIPTION "reads IRC texts"
#define PLUGIN_IRC_SENSOR_DESCRIPTION "IRC plugin sensor"
#define PLUGIN_IRC_COLLECTOR_DESCRIPTION "IRC plugin collector"

#ifdef __cplusplus
extern "C"
#endif

/* structs */
struct _irc_t 
{
	gchar	server[128];
	gchar	port[5]; /* hmmm.. only 5 needed for ip4 */
	gchar	channel[512];
	gchar	nick[9]; 
	gchar	username[128];
};
typedef struct _irc_t irc_t;


/* globals */
	gboolean activate = FALSE;
	gchar hostname[64];
	gchar line[SENSOR_MAXLEN];
	gint endstring;
	irc_t sensor_irc_config;
	gint log_on = 0;             /* debuging log on/off         */
	FILE *log;                  /* debugging file              */
	gchar buf[SENSOR_MAXLEN];           /* global text data buffer     */
	gchar localhost[128];			/* the local machine's name    */
	messaging_object *irc_sensor_mo;
	messaging_object *IRC_collector_mo;
	gint irc_gint_tag;
	gint sensor_s;
	irc_t sensor_irc_config_new;
	gint sensor_irc_config_Default = TRUE;
	GtkWidget *entry58;
	GtkWidget *entry59;
	GtkWidget *entry60;
	GtkWidget *entry61;
	GtkWidget *entry62;
	GtkWidget *vbox109;

/* protos */
gpointer sensor_handle_irc_socket(gpointer data,gint source,GdkInputCondition condition);
gint call_socket(gchar *hostname);
gint readln(gchar *buf,gint s);
gint writeln(gchar *buf,gint s);
gpointer on_msg(gchar *from,gchar *to,gchar *msg,gint s);
gpointer on_join(gchar *who,gchar *channel,gint s);

/* functions */
gboolean sensor_irc_join_channel()
{
	strcpy((char*)hostname, (char*)(&sensor_irc_config)->server);
	gethostname(localhost, 64);
	if ((sensor_s=call_socket(hostname))==-1)
	{
		g_print("IRC sensor : could not connect to %s, aborting\n", hostname);
		return FALSE;
	}
	sprintf(buf, "NICK %s\n", (&sensor_irc_config)->nick);
	writeln(buf,sensor_s);
	sprintf(buf, "USER %s 1 1 %s\n", (&sensor_irc_config)->username, SENSOR_IRCGECOS);
	writeln(buf,sensor_s);
	do
	{
		readln(line,sensor_s);
		endstring = (messaging_db_regexpmatch(line,(gchar*)"+i")) && (messaging_db_regexpmatch(line,(gchar*)(&(&sensor_irc_config)->nick)));
		if (strncmp(line,"ERROR",5)==0) {g_print("IRC sensor ERROR\n");exit(2);}
	} while (endstring < 1);
	sprintf(buf, "JOIN %s\n", (char*)(&(&sensor_irc_config)->channel));
	writeln(buf,sensor_s);
	fflush(NULL);
	/* attach the stream to GLIB */
	irc_gint_tag = gdk_input_add(sensor_s,(GdkInputCondition)(GDK_INPUT_READ|GDK_INPUT_EXCEPTION),(GdkInputFunction)sensor_handle_irc_socket, NULL);
	return TRUE;
}

/*===[ call_socket ]==========================================================
  Connect to port IRCPORT on host 'hostname', returning the socket
  value.  Return -1 on any errors.
============================================================================*/
gint call_socket(gchar *hostname)
{
	struct sockaddr_in sa;
	struct hostent     *hp;
	gint s;

	if ((hp=gethostbyname(hostname))==NULL)
	{
		errno=ECONNREFUSED;
		return(-1);
	}
	bzero(&sa, sizeof(sa));
	bcopy(hp->h_addr, (gchar *)&sa.sin_addr, hp->h_length);
	sa.sin_family = hp->h_addrtype;
	sa.sin_port = htons((u_short)atoi(SENSOR_IRCPORT));
	if((s=socket(hp->h_addrtype, SOCK_STREAM, 0)) < 0)
		return(-1);
	if(connect(s, (const sockaddr*)&sa, sizeof(sa)) < 0)
	{
		close(s);
		return(-1);
	}
	return s;
}

/*===[ readln ]=======================================================
  Read all characters from socket s until a newline.  Put resulting
  string in buf, ignoring all after the MAXLEN'th character.
====================================================================*/
gint readln(gchar *buf,gint s)
{
	gint to=0;
	gchar c;
	/* bwarf, this check fixed a segfault inside glib, a pretty hard one so Never Again */
	if (buf==NULL)
		return FALSE;
	do
	{
		if(read(s, &c, 1)<1) { return FALSE;}
		if((c >= ' ') || (c <= 126))
			if(to<SENSOR_MAXLEN-1)
				buf[to++] = c;
	} while (c != '\n');
	buf[to] = '\0';
	return TRUE;
}

gint writeln(gchar *buf,gint s)
{	/* Send contents of buf to socket s.  Return 0 if the entire buf wasn't written.  Return 1 on a successful write. */
	gint to = 0;

	buf[SENSOR_MAXLEN-1] = '\0';
	if( write(s, buf, strlen(buf)) < to )
		return FALSE;
	return TRUE;
}

gpointer privmsg(gchar *from,gchar *line,gint s)
{	/* Got a private message from 'from'.  Find out what he wants. */
	gchar *text;
	gchar *to;

	if((text = index(line, ' ')) != 0 )
	{
		*(text) = '\0'; 
		text += 2;
	} 
	to = line;
	on_msg(from, to, text,s);
	return NULL;
}

gint parse(gchar *line,gint s)
{
	gchar *from;
	gchar *comm;
	gchar *rest;
	gint  numeric;
 
	if(*(line + strlen(line) - 1) == '\n') { *(line + strlen(line) - 1) = '\0';}
	if(*line == ':')
	{
		if((comm = index(line, ' ')) == 0) { return FALSE;}
		*(comm++) = '\0';
		from = line + 1; 
	} else {
		comm = line;
		from = NULL;
	}
	if ((rest = index(comm, ' ')) == 0) { return FALSE;}
	*(rest++) = '\0';
	if ((numeric = atoi(comm))) {}
	/*numbered_command(from, numeric, rest)*/
	else if (strcmp(comm, "JOIN") == 0) {on_join(from, rest,s);}
	else if (strcmp(comm, "PING") == 0)
	{
		g_strdup_printf(buf, "PONG %s\n", localhost);
		writeln(buf,s);
	}
	else if (strcmp(comm,"ERROR") == 0)
	{
		gdk_input_remove(irc_gint_tag);
		g_strdup_printf(buf, "QUIT\n");
	    writeln(buf,sensor_s);
		fflush(NULL);
		close(sensor_s);
		sensor_irc_join_channel();
	}
	else if (strcmp(comm,"KICK") == 0)
	{
		gdk_input_remove(irc_gint_tag);
		g_strdup_printf(buf, "QUIT\n");
	    writeln(buf,sensor_s);
		fflush(NULL);
		close(sensor_s);
		sensor_irc_join_channel();
	}
	else if (strcmp(comm,"BAN") == 0)
	{
		gdk_input_remove(irc_gint_tag);
		g_strdup_printf(buf, "QUIT\n");
	    writeln(buf,sensor_s);
		fflush(NULL);
		close(sensor_s);
		irc_sensor_mo->status = Blocking;
	}
	return TRUE;
}

#ifdef __cplusplus
extern "C"
#endif
gint plugin_collector_irc_destruct(messaging_object *MO)
{   gint result;
	MO->destruct = NULL;
	result = messaging_db_collector_unregister(MO);
	return result;
}

#ifdef __cplusplus
extern "C"
#endif
gboolean plugin_collector_irc_procedure(messaging_object *MO)
{
    /* nothing to do */
	/* reset procedure_running */
	MO->procedure_running = FALSE;
    return TRUE;
}

#ifdef __cplusplus
extern "C"
#endif
gboolean plugin_collector_irc_procedure_cleanup(messaging_object *MO)
{
    /* nothing to do */
    /* reset procedure_running */
    MO->procedure_running = FALSE;
    return TRUE;
}

#ifdef __cplusplus
extern "C"
#endif
G_MODULE_EXPORT gint plugin_collector_irc_init(messaging_object *MO)
{
	IRC_collector_mo = MO;
	/* setup collector for the messaging_db_pipeline_in code */
	/* collector do not have init of destruct handlers */
	messaging_db_collector_register(IRC_collector_mo,PLUGIN_IRC_NAME_COLLECTOR,PLUGIN_IRC_COLLECTOR_DESCRIPTION,PLUGIN_IRC_SENSOR_DESCRIPTION,PLUGIN_IRC_SENSOR_DESCRIPTION,plugin_collector_irc_procedure,plugin_collector_irc_procedure_cleanup,plugin_collector_irc_init,plugin_collector_irc_destruct);
	return TRUE;
}

gpointer sensor_handle_irc_socket(gpointer _data,gint source,GdkInputCondition condition)
{
	gchar *line[SENSOR_MAXLEN];
	gchar *data[SENSOR_MAXLEN];
	
	readln((gchar*)line,source);
	g_memmove(data,line,SENSOR_MAXLEN);
	parse((gchar*)line,source);
	/* copy message line into sensor MO */
    g_memmove(irc_sensor_mo->MDO->rawdata,data,strlen((const char*)data)-1);
    /* poll the db , it will accept the message and search for collector
     * objects that accept the data. */
	messaging_db_pipeline_in(irc_sensor_mo);
	return NULL;
}

gpointer on_APPLY_IRC_SENSOR_clicked(GtkButton *button,gpointer user_data)
{
  gchar *b;
  messaging_object *MO = (messaging_object*)user_data;
	
  b=gtk_entry_get_text(GTK_ENTRY(entry58));strcpy((char*)((&sensor_irc_config_new)->server),b);
  b=gtk_entry_get_text(GTK_ENTRY(entry59));strcpy((char*)((&sensor_irc_config_new)->port),b);
  b=gtk_entry_get_text(GTK_ENTRY(entry60));strcpy((char*)((&sensor_irc_config_new)->channel),b);
  b=gtk_entry_get_text(GTK_ENTRY(entry61));strcpy((char*)((&sensor_irc_config_new)->nick),b);
  b=gtk_entry_get_text(GTK_ENTRY(entry62));strcpy((char*)((&sensor_irc_config_new)->username),b);
  sensor_irc_config_Default = FALSE;
  /* destruct and re-init MO */
  (MO->destruct)(MO);
  (MO->init)(MO);
  return NULL;
}


#ifdef __cplusplus
extern "C"
#endif
GtkWidget *plugin_sensor_irc_init_configPanel(messaging_object *MO,gint XID)
{
  irc_t irc_config;
  GtkWidget *label415;
  GtkWidget *vbox110;
  GtkWidget *table24;
  GtkWidget *label416;
  GtkWidget *label417;
  GtkWidget *label418;
  GtkWidget *label419;
  GtkWidget *label420;
  GtkWidget *button159;
  GtkWidget *Plug;

	Plug = messaging_db_gtkplugnew(XID,"plugin_sensor_irc_init_configPanel");
	gtk_widget_show(Plug);
	/* parse config */
  g_memmove(&irc_config,irc_sensor_mo->configRuntime,sizeof(irc_t));
	/* build the GUI */
  vbox109 = gtk_vbox_new (FALSE, 0);
  gtk_widget_set_name (vbox109, "vbox109");
  gtk_widget_ref (vbox109);
  gtk_widget_show(vbox109);
  gtk_container_add(GTK_CONTAINER(Plug),vbox109);

  label415 = gtk_label_new (("\nNOTE: any changes to the IRC plugin require a full plugin restart.\nThis might stall gMessaging System for about a minute... \n"));
  gtk_widget_set_name (label415, "label415");
  gtk_widget_ref (label415);
  gtk_object_set_data_full (GTK_OBJECT (vbox109), "label415", label415,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label415);
  gtk_box_pack_start (GTK_BOX (vbox109), label415, FALSE, FALSE, 0);

  vbox110 = gtk_vbox_new (FALSE, 0);
  gtk_widget_set_name (vbox110, "vbox110");
  gtk_widget_ref (vbox110);
  gtk_object_set_data_full (GTK_OBJECT (vbox109), "vbox110", vbox110,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox110);
  gtk_box_pack_start (GTK_BOX (vbox109), vbox110, TRUE, TRUE, 0);

  table24 = gtk_table_new (5, 2, FALSE);
  gtk_widget_set_name (table24, "table24");
  gtk_widget_ref (table24);
  gtk_object_set_data_full (GTK_OBJECT (vbox109), "table24", table24,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (table24);
  gtk_box_pack_start (GTK_BOX (vbox110), table24, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (table24), 6);
  gtk_table_set_row_spacings (GTK_TABLE (table24), 6);
  gtk_table_set_col_spacings (GTK_TABLE (table24), 10);

  label416 = gtk_label_new (("Server"));
  gtk_widget_set_name (label416, "label416");
  gtk_widget_ref (label416);
  gtk_object_set_data_full (GTK_OBJECT (vbox109), "label416", label416,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label416);
  gtk_table_attach (GTK_TABLE (table24), label416, 0, 1, 0, 1,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_label_set_justify (GTK_LABEL (label416), GTK_JUSTIFY_LEFT);

  label417 = gtk_label_new (("port"));
  gtk_widget_set_name (label417, "label417");
  gtk_widget_ref (label417);
  gtk_object_set_data_full (GTK_OBJECT (vbox109), "label417", label417,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label417);
  gtk_table_attach (GTK_TABLE (table24), label417, 0, 1, 1, 2,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_label_set_justify (GTK_LABEL (label417), GTK_JUSTIFY_LEFT);

  label418 = gtk_label_new (("Channel"));
  gtk_widget_set_name (label418, "label418");
  gtk_widget_ref (label418);
  gtk_object_set_data_full (GTK_OBJECT (vbox109), "label418", label418,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label418);
  gtk_table_attach (GTK_TABLE (table24), label418, 0, 1, 2, 3,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_label_set_justify (GTK_LABEL (label418), GTK_JUSTIFY_LEFT);

  label419 = gtk_label_new (("Nick"));
  gtk_widget_set_name (label419, "label419");
  gtk_widget_ref (label419);
  gtk_object_set_data_full (GTK_OBJECT (vbox109), "label419", label419,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label419);
  gtk_table_attach (GTK_TABLE (table24), label419, 0, 1, 3, 4,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);

  label420 = gtk_label_new (("Username"));
  gtk_widget_set_name (label420, "label420");
  gtk_widget_ref (label420);
  gtk_object_set_data_full (GTK_OBJECT (vbox109), "label420", label420,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label420);
  gtk_table_attach (GTK_TABLE (table24), label420, 0, 1, 4, 5,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);

  entry58 = gtk_entry_new ();
  gtk_widget_set_name (entry58, "entry58");
  gtk_widget_ref (entry58);
  gtk_object_set_data_full (GTK_OBJECT (vbox109), "entry58", entry58,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_entry_set_text(GTK_ENTRY(entry58),(char*)(&irc_config)->server);
  gtk_widget_show (entry58);
  gtk_table_attach (GTK_TABLE (table24), entry58, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  entry59 = gtk_entry_new ();
  gtk_widget_set_name (entry59, "entry59");
  gtk_widget_ref (entry59);
  gtk_object_set_data_full (GTK_OBJECT (vbox109), "entry59", entry59,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_entry_set_text(GTK_ENTRY(entry59),(char*)(&irc_config)->port);
  gtk_widget_show (entry59);
  gtk_table_attach (GTK_TABLE (table24), entry59, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  entry60 = gtk_entry_new ();
  gtk_widget_set_name (entry60, "entry60");
  gtk_widget_ref (entry60);
  gtk_object_set_data_full (GTK_OBJECT (vbox109), "entry60", entry60,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_entry_set_text(GTK_ENTRY(entry60),(char*)(&irc_config)->channel);
  gtk_widget_show (entry60);
  gtk_table_attach (GTK_TABLE (table24), entry60, 1, 2, 2, 3,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  entry61 = gtk_entry_new ();
  gtk_widget_set_name (entry61, "entry61");
  gtk_widget_ref (entry61);
  gtk_object_set_data_full (GTK_OBJECT (vbox109), "entry61", entry61,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_entry_set_text(GTK_ENTRY(entry61),(char*)(&irc_config)->nick);
  gtk_widget_show (entry61);
  gtk_table_attach (GTK_TABLE (table24), entry61, 1, 2, 3, 4,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  entry62 = gtk_entry_new ();
  gtk_widget_set_name (entry62, "entry62");
  gtk_widget_ref (entry62);
  gtk_object_set_data_full (GTK_OBJECT (vbox109), "entry62", entry62,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_entry_set_text(GTK_ENTRY(entry62),(char*)(&irc_config)->username);
  gtk_widget_show (entry62);
  gtk_table_attach (GTK_TABLE (table24), entry62, 1, 2, 4, 5,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  //button159 = gnome_stock_button (GNOME_STOCK_BUTTON_APPLY);
  button159 = gtk_button_new_with_label("Apply");
  gtk_widget_set_name (button159, "button159");
  gtk_widget_ref (button159);
  gtk_object_set_data_full (GTK_OBJECT (vbox109), "button159", button159,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button159);
  gtk_box_pack_start (GTK_BOX (vbox109), button159, FALSE, FALSE, 0);
  gtk_signal_connect (GTK_OBJECT (button159), "clicked",
                      GTK_SIGNAL_FUNC (on_APPLY_IRC_SENSOR_clicked),irc_sensor_mo);

  if (vbox109 == NULL)
    {
        g_print((gchar*)"sensor_syslog_init_configPanel ERROR\n");
    } else {
        g_print((gchar*)"sensor_syslog_init_configPanel OK\n");
    }

    return Plug;
}

#ifdef __cplusplus
extern "C"
#endif
gboolean plugin_sensor_irc_procedure(messaging_object *MO)
{
	/* nothing to do */
    /* reset procedure_running */
    MO->procedure_running = FALSE;
	return TRUE;
}

#ifdef __cplusplus
extern "C"
#endif
gboolean plugin_sensor_irc_procedure_cleanup(messaging_object *MO)
{
    /* nothing to do */
    /* reset procedure_running */
    MO->procedure_running = FALSE;
    return TRUE;
}

#ifdef __cplusplus
extern "C"
#endif
gint plugin_sensor_irc_destruct(messaging_object *MO)
{	gint result;

	gdk_input_remove(irc_gint_tag);
	g_strdup_printf(buf, "QUIT\n");
	writeln(buf,sensor_s);
	fflush(NULL);
	close(sensor_s);
	MO->destruct = NULL;
	result = messaging_db_sensor_unregister(MO);
	return result;	
}

#ifdef __cplusplus
extern "C"
#endif
gint plugin_sensor_irc_activate(messaging_object *MO)
{
    /* still dummy */
    return TRUE;
}

#ifdef __cplusplus
extern "C"
#endif
G_MODULE_EXPORT gint plugin_sensor_irc_init(messaging_object *MO)
{
	irc_sensor_mo = MO;
	g_message("Initialising IRC sensor, make sure the default config (gms sourcecode ./plugins/plugin_sensor_irc.h) is reachable");
	/* set default config */
	if (sensor_irc_config_Default == TRUE)
	{
	  	g_print("using DEFAULTS for irc_config\n");
  		strcpy((char*)(&sensor_irc_config)->server,SENSOR_IRCSERVER);
	  	strcpy((char*)(&sensor_irc_config)->port,SENSOR_IRCPORT);
  		strcpy((char*)(&sensor_irc_config)->channel,SENSOR_IRCCHANNEL);
	  	strcpy((char*)(&sensor_irc_config)->nick,SENSOR_IRCNAME);
  		strcpy((char*)(&sensor_irc_config)->username,SENSOR_USERNAME);
	} else {
	  	g_print("using irc_config_new for irc_config\n");
  		g_memmove(&sensor_irc_config,&sensor_irc_config_new,sizeof(irc_t));
	}
	/* register new sensor */
	messaging_db_sensor_register(MO,PLUGIN_IRC_NAME_SENSOR,PLUGIN_IRC_SENSOR_DESCRIPTION,PLUGIN_IRC_SENSOR_DESCRIPTION,plugin_sensor_irc_procedure,plugin_sensor_irc_procedure_cleanup,plugin_sensor_irc_init_configPanel,plugin_sensor_irc_init,plugin_sensor_irc_activate,plugin_sensor_irc_destruct);
	/* set default config */
	g_memmove(MO->configRuntime,&sensor_irc_config,sizeof(irc_t));
	/* join chan */
	sensor_irc_join_channel();
	return TRUE;
}

gint is_channel(gchar *to)
{	/* Sees if a name is a channel name. */
    return (isdigit(*to) || (*to == '+') || (*to == '#') || (*to == '-'));
}

gchar *__strcasestr (gchar *s1,gchar *s2)
{	/* NOT used.  I just pulled it out of Sagebot for possible future use. */
	gchar n1[256], n2[256];
	gint i;

	for (i=0;s1[i] != '\0';i++)
		n1[i] = toupper (s1[i]);
	n1[i] = '\0';
	for (i=0;s2[i] != '\0';i++)
		n2[i] = toupper (s2[i]);
	n2[i] = '\0';

	return (strstr (n1, n2));
}

gpointer on_join(gchar *who,gchar *channel,gint s)
{	/* "who" has joined channel "channel" - do whatever */
	sprintf(buf, "PRIVMSG %s Hey %s!  Welcome to %s.\n", channel, who, channel);
	writeln(buf,s);
	return NULL;
}

gpointer on_msg(gchar *from,gchar *to,gchar *msg,gint s)
{	/* A message was sent from "from" to "to", the text is in "msg" */
	gchar *replyto;
	gchar *you=(gchar*)"bastardAI";
	gint i;

    if(is_channel(to)) replyto=to;
    else {replyto=from; from=you; }
	for (i=0;i<(gint)strlen(msg);i++)
		if ((strncmp((gchar*)((gint)msg+i)," ",1)==0)||(strncmp((gchar*)((gint)msg+i),"\n",1)==0)||(strncmp((gchar*)((gint)msg+i),"\r",1)==0))
			g_memmove((gchar*)((gint)msg+i),"_",1);
	return NULL;
}

