/*
 * basic devel visual. 1st one ever created.
 * 26-07-1999, BastardAI, moved code out of the main db code into this file
 *
 */
#define __x86__


/*
 * INCLUDES
 */
#include "messaging.h"
#include "messaging_mobject_structs.h"
#include "messaging_mobject_api.h"
#include "messaging_db.h"
#include <gdk/gdk.h>
#include <gdk_imlib.h>
#include <gtk/gtk.h>
#include <gmodule.h>
#include <stdio.h>

/* 
 * DEFINES 
 */
#define VISUAL_MO_ANIMAPPLET_NAME "visual APPLET MO"
#define VISUAL_MO_ANIMAPPLET_DESCRIPTION "animated applet visual"
#define WIDGET_HEIGHT   48

/*
 * STRUCTS...
 */
struct _messaging_applet_pixmap_struct
{
	GtkWidget *bin;     /* This holds either the drawing area or the label */
	GtkWidget *label;   /* The widget that holds the label with the mail information */
	GtkWidget *containee;   /* Points to whatever we have inside the bin */
	GtkWidget *da;      /* The drawing area */
	GdkPixmap *pixmap;
	GdkBitmap *mask;
	GtkWidget *applet;      /* the applet */
	gint nframe;        /* current frame on the animation */
	gint frames;        /* number of frames on the pixmap */
};
typedef struct _messaging_applet_pixmap_struct messaging_applet_pixmap_struct;

/* This is a dummy pixmap we use when a pixmap can't be found. */
static gchar *dummy_pixmap_xpm[] = {
/* columns rows colors chars-per-pixel */
(gchar*)"1 1 1 1",
(gchar*)"  c None",
/* pixels */
(gchar*)" ",
(gchar*)" "
};

/*
 * VARIS
 */
GtkWidget *bin;
GtkWidget *plug;
messaging_applet_pixmap_struct *map_main = NULL;
gint animations_done;
gint animating = FALSE;
messaging_object *animvisual;

static gint plugin_visual_animapplet_update (gpointer data)
{   /* update the applet */
	messaging_applet_pixmap_struct *map = (messaging_applet_pixmap_struct*)data;
	g_print("plugin_visual_animapplet_update\n");
	map->nframe = (map->nframe + 1) % map->frames;
	gtk_widget_draw (map->da, NULL);
	if ((animations_done--)==0)
	{
		animating = FALSE;
	    /* reset procedure_running */
		g_print("plugin_visual_animapplet_update; reset procedure_running\n");
		animvisual->procedure_running = FALSE;
		return FALSE;
	}
	return TRUE;
}

gpointer plugin_visual_animapplet_do_animate(void)
{
	animations_done = 44;
	if (!animating)
	{
		g_print("plugin_visual_animapplet_do_animate; added animation\n");
		gtk_timeout_add(40,plugin_visual_animapplet_update,map_main);
		animating = TRUE;
	}
	else
		g_print("plugin_visual_animapplet_do_animate; animation already running\n");
	return NULL;
}

GdkImlibImage*
create_image                           (const gchar     *filename)
{
    GdkImlibImage *image;
    GString *pathname;
	FILE *impl_file_1,*impl_file_2;

    pathname = g_string_new(filename);
	pathname = g_string_prepend(pathname,"/usr/share/pixmaps/");
    if ((impl_file_1 = fopen(pathname->str,"r")) == NULL)
    {
		fclose(impl_file_1);
		g_string_free(pathname,TRUE);
		pathname = g_string_new(filename);
		pathname = g_string_prepend(pathname,"/usr/local/share/pixmaps/");
		if ((impl_file_2 = fopen(pathname->str,"r")) == NULL)
		{
			fclose(impl_file_2);
        	g_warning ("Couldn't find pixmap file: %s", filename);
			return NULL;
		}
		fclose(impl_file_2);
    }
	fclose(impl_file_1);
    image = gdk_imlib_load_image (pathname->str);
	g_string_free(pathname,TRUE);

    return image;
}

static GtkWidget*
create_dummy_pixmap                    (GtkWidget       *widget)
                        //                gboolean         gnome_pixmap)
{
  GdkColormap *colormap;
  GdkPixmap *gdkpixmap;
  GdkBitmap *mask;
  GtkWidget *pixmap;

//  if (gnome_pixmap)
//    {
//      return gnome_pixmap_new_from_xpm_d (dummy_pixmap_xpm);
//    }

  colormap = gtk_widget_get_colormap (widget);
  gdkpixmap = gdk_pixmap_colormap_create_from_xpm_d (NULL, colormap, &mask,
                                                     NULL, dummy_pixmap_xpm);
  if (gdkpixmap == NULL)
    g_error ("Couldn't create replacement pixmap.");
  pixmap = gtk_pixmap_new (gdkpixmap, mask);
  gdk_pixmap_unref (gdkpixmap);
  gdk_bitmap_unref (mask);
  return pixmap;
}

GtkWidget*
create_pixmap                          (GtkWidget       *widget,
                                        const gchar     *filename)
//,                                        gboolean         gnome_pixmap)
{
	GtkWidget *pixmap;
	GdkColormap *colormap;
	GdkPixmap *gdkpixmap;
	GdkBitmap *mask;
	GString *pathname;
	FILE *impl_file_1,*impl_file_2;

	pathname = g_string_new(filename);
	pathname = g_string_prepend(pathname,"/usr/share/pixmaps/");
	if ((impl_file_1 = fopen(pathname->str,"r")) == NULL)
	{
		fclose(impl_file_1);
		if ((impl_file_2 = fopen(pathname->str,"r")) == NULL)
		{
			fclose(impl_file_2);
			g_warning ("Couldn't find pixmap file: %s", filename);
			return create_dummy_pixmap (widget);
		}
		fclose(impl_file_2);
	}
	fclose(impl_file_1);

//	if (gnome_pixmap)
//    {
//      pixmap = gnome_pixmap_new_from_file (pathname);
//      g_free (pathname);
//      return pixmap;
//    }

  colormap = gtk_widget_get_colormap (widget);
  gdkpixmap = gdk_pixmap_colormap_create_from_xpm (NULL, colormap, &mask,
                                                   NULL, pathname->str);
  if (gdkpixmap == NULL)
    {
      g_warning ("Couldn't create pixmap from file: %s",pathname->str);
      g_string_free (pathname,TRUE);
      return create_dummy_pixmap (widget);
    }
	g_string_free(pathname,TRUE);

  pixmap = gtk_pixmap_new (gdkpixmap, mask);
  gdk_pixmap_unref (gdkpixmap);
  gdk_bitmap_unref (mask);
  return pixmap;
}

gpointer plugin_visual_animapplet_load_animation (messaging_applet_pixmap_struct *map)
{
	gint width, height;
	GdkImlibImage *im;

	im = create_image ("heart.png");
	width = im->rgb_width;
	height = im->rgb_height;
	gdk_imlib_render (im, width, height);
	map->pixmap = gdk_imlib_copy_image (im);
	map->mask = gdk_imlib_copy_mask (im);
	map->frames = width / WIDGET_HEIGHT;
	map->nframe = 1;
	gdk_imlib_destroy_image (im);
	return NULL;
}

static gint plugin_visual_animapplet_icon_expose (GtkWidget *widget, GdkEventExpose *event, gpointer data)
{	/* this gets called when we have to redraw the nice icon */
	messaging_applet_pixmap_struct *map = (messaging_applet_pixmap_struct*)data;
	gdk_draw_pixmap (map->da->window, map->da->style->black_gc,map->pixmap, map->nframe * WIDGET_HEIGHT,0, 0, 0, WIDGET_HEIGHT, WIDGET_HEIGHT);
	return TRUE;
}

void plugin_visual_animapplet_destroy_signal(GtkObject *object,gpointer user_data)
{
    return;
}
#ifdef __cplusplus
extern "C"
#endif
GtkWidget *plugin_visual_animapplet_init_visualPanel(messaging_object *MO,gint XID)
{
	/* create the pixmap we are going to put on the applet */
	if (map_main!=NULL) g_free(map_main);
	map_main = g_new(messaging_applet_pixmap_struct,1);
	/* The drawing area */
	gtk_widget_push_visual (gdk_imlib_get_visual ());
	gtk_widget_push_colormap (gdk_imlib_get_colormap ());
	map_main->da = gtk_drawing_area_new ();
	gtk_widget_pop_colormap ();
	gtk_widget_pop_visual ();
	gtk_widget_ref (map_main->da);
	gtk_drawing_area_size (GTK_DRAWING_AREA(map_main->da), 48, 48);
	gtk_signal_connect (GTK_OBJECT(map_main->da),"expose_event",(GtkSignalFunc)plugin_visual_animapplet_icon_expose,map_main);
	gtk_widget_set_events(GTK_WIDGET(map_main->da),GDK_EXPOSURE_MASK);
	gtk_widget_show (map_main->da);
	plugin_visual_animapplet_load_animation(map_main);
	bin = messaging_db_gtkplugnew(messaging_db_alarmGETsocketXID(),"plugin_visual_animapplet_buildVisual");
	gtk_container_add (GTK_CONTAINER (bin), map_main->da);
	gtk_widget_show (bin);
	gtk_signal_connect(GTK_OBJECT(bin),"destroy",GTK_SIGNAL_FUNC(plugin_visual_animapplet_destroy_signal),NULL);
	return bin;
}

#ifdef __cplusplus
extern "C"
#endif
gint plugin_visual_animapplet_procedure(messaging_object *MO)
{
g_print("plugin_visual_animapplet_procedure; dataPassedOver = %i\n",MO->dataPassedOver);
	animvisual = MO;
	if (MO->MDO->Boolean)
	{
		plugin_visual_animapplet_do_animate();
	}
	/* mark data as transfered */
	MO->dataPassedOver = TRUE;
g_print("plugin_visual_animapplet_procedure; dataPassedOver = %i\n",MO->dataPassedOver);
    return TRUE;
}

#ifdef __cplusplus
extern "C"
#endif
gint plugin_visual_animapplet_procedure_cleanup(messaging_object *MO)
{
    return TRUE;
}

#ifdef __cplusplus
extern "C"
#endif
GtkWidget *plugin_visual_animapplet_init_configPanel(messaging_object *MO,gint XID)
{
	GtkWidget *label;

	plug = messaging_db_gtkplugnew(XID,"plugin_visual_animapplet_init_configPanel");
	gtk_widget_show_all(plug);
	label = gtk_label_new (("The animated applet visual has no configuration."));
	gtk_widget_set_name (label, "label");
	gtk_widget_show(label);
	gtk_container_add(GTK_CONTAINER(plug),label);
	if (label == NULL)
	{
		g_print("visual_animatedapplet_init_configPanel ERROR\n");
	}
	return plug;
}

#ifdef __cplusplus
extern "C"
#endif
gint plugin_visual_animapplet_destruct(messaging_object *MO)
{	gint result;
	MO->destruct = NULL;
	result = messaging_db_visual_unregister(MO);
    return result;
}

#ifdef __cplusplus
extern "C"
#endif
gint plugin_visual_animapplet_activate(messaging_object *MO)
{   gint result;
    result = TRUE;
    return result;
}

#ifdef __cplusplus
extern "C"
#endif
G_MODULE_EXPORT gint plugin_visual_animapplet_init(messaging_object *MO)
{

    /* register DEVEL as a visual */
	if (messaging_db_visual_register(MO,VISUAL_MO_ANIMAPPLET_NAME,VISUAL_MO_ANIMAPPLET_DESCRIPTION,"",plugin_visual_animapplet_procedure,plugin_visual_animapplet_procedure_cleanup,plugin_visual_animapplet_init_configPanel,plugin_visual_animapplet_init_visualPanel,plugin_visual_animapplet_init,plugin_visual_animapplet_activate,plugin_visual_animapplet_destruct))
	{
	    // This is a special visual, the alarm, so get it's special XID
	} else {
	    g_print("Visual animated applet register error\n");
	    messaging_db_visual_unregister(MO);
		return FALSE;
	}
	/* make MO locally accessable */
	animvisual = MO;
    return TRUE;
}

