// DL sensor,
//  1-11-2000, jarl van katwijk, started,
// 22-11-2000, jarl van katwijk, got 1st functional, but still dummy implemented, Orb server
// 25-11-2000, jarl van katwijk, implemented more orb server functions
// 23-02-2001, jarl van katwijk, converted code to BL 0.5 OOP model

#include "messaging.h"
#include "plugin_sensor_DL.h"
#include "plugin_sensor_PL_main.h"
#include "gmodule.h"
#include <stdlib.h>
#include <fstream.h>
#include <unistd.h>
#include <string.h> /* memset */
#include <sys/utsname.h>
#include <errno.h>
#include <sys/stat.h>


/************************************
  Globals
  ***********************************/
static pthread_t DLtree;
static gint DLthread;
static engine* Engine = NULL;
static glong Node;
static glong Data;
static CORBA::ORB_var orb;
static PortableServer::POA_var poa;

/*
 * Prototypes
 */
//none yet

/*
 * Code
 */

// --- Corba implementations:
// Representation Orb ---
piper::DL2BL::uriS* Representation_i::upload(const char* xmldocument,long int dlid,const char* password) {
	// This function receives XML data from the DL and puts it on the BL pipeline
    // so that the PL sensor can collect it.
    gint xmldocumentlength;
	piper::DL2BL::uriS* uri = new piper::DL2BL::uriS();

	// Build complete Piper URI out of BL uri [ hmm, bad naming :( ] :
    g_log(PIPER_BL_LOG_DOMAIN,G_LOG_LEVEL_MESSAGE,"Got new XML from DL %li",dlid);
	uri->instanceID = Engine->secure_node_get_uri(Node,Engine->ENGINE_DL_ID,Engine->ENGINE_DL_PASSWORD->str)->instanceID;
	uri->subnetID = Engine->secure_node_get_uri(Node,Engine->ENGINE_DL_ID,Engine->ENGINE_DL_PASSWORD->str)->subnetID;
	uri->nodeID = Engine->secure_node_get_uri(Node,Engine->ENGINE_DL_ID,Engine->ENGINE_DL_PASSWORD->str)->nodeID;
	(&uri->status)->progress = 0;

    // Fill MO with xml data
    xmldocumentlength = strlen(xmldocument);
    if (xmldocumentlength>DATA_RAWLEN) {
         g_log(PIPER_BL_LOG_DOMAIN,G_LOG_LEVEL_WARNING,"FIXME: XML document too large to fit into MDO->rawdata\n");
         (&uri->status.state)->error = piper::DL2BL::ERRORRAWMEMOVERFLOW;
    }
    Engine->secure_data_set_rawdata(Data,(gchar*)xmldocument,xmldocumentlength,Engine->ENGINE_DL_ID,Engine->ENGINE_DL_PASSWORD->str); /* Copy XML into data block */

//g_print("Sensor dname = %s, NodeID = %li\n",Engine->secure_node_get_dname(Node,Engine->ENGINE_DL_ID,Engine->ENGINE_DL_PASSWORD->str)->str,Node);
//g_print("sensor_DL_description = %s\n",sensor_DL_description());


    Engine->secure_node_set_datadescription(Node,(gchar*)sensor_DL_description(),Engine->ENGINE_DL_ID,Engine->ENGINE_DL_PASSWORD->str); /* Set data description */


    // Have MO output its data to pipeline
    if (Engine->pipeline_in(Node,Engine->ENGINE_DL_ID,Engine->ENGINE_DL_PASSWORD->str)) {
		(&uri->status.state)->error = piper::DL2BL::ERRORNONE;
	} else {
		(&uri->status.state)->error = piper::DL2BL::ERRORUNKNOWN;
	}

    // Finish URI
	(&uri->status.state)->constructed = TRUE;
	(&uri->status.state)->blocking = (Engine->secure_node_get_status(Node,Engine->ENGINE_DL_ID,Engine->ENGINE_DL_PASSWORD->str) == Blocking);
	(&uri->status.state)->temporary = (Engine->secure_node_get_nodetype(Node,Engine->ENGINE_DL_ID,Engine->ENGINE_DL_PASSWORD->str) == TemporaryNode);
	(&uri->status.state)->isolated = (Engine->secure_node_get_currentrelations(Node,Engine->ENGINE_DL_ID,Engine->ENGINE_DL_PASSWORD->str)>0);

    return uri;
}


char* Representation_i::download(const piper::DL2BL::uriS &uri,long int dlid,const char* password)
{	// This function returns PL results back to the DL.
	char* result = "PL returned nothing";
	return CORBA::string_dup(result);
}

CORBA::Boolean Representation_i::update(const char *xmldocument,const piper::DL2BL::uriS &uri,long int dlid,const char* password)
{	// This function updates an initialised\running PL network by XML data from the DL.
	CORBA::Boolean result = FALSE;
	return result;
}

// Obtain Orb ---
piper::DL2BL::statusS Obtain_i::uriStatus(const piper::DL2BL::uriS &uri,long int dlid,const char* password)
{
	piper::DL2BL::statusS result;

	result.state.error = piper::DL2BL::ERRORUNKNOWN;
	result.state.constructed = TRUE;
	result.state.blocking = FALSE;
	result.state.temporary = FALSE;
	result.state.isolated = FALSE;
	result.progress = 0;
	return result;
}

char* Obtain_i::uriInfo(const char* password,const piper::DL2BL::uriS &uri)
{
	char* result = "";
	return CORBA::string_dup(result);
}

/*
void* plugin_sensor_DL_runBBLclientORB(gpointer data)
{	// thread for connection to BBL
    CORBA::Object_var BL2PL_corba_object;
    gint dummy_argc = 1;
    gchar *dummy_argv[1];
    FILE *ifp;
    gchar *ior;
    gchar filebuffer[1024];
    GString *iorFile;
    // build dummy args 
    dummy_argc = 1;
    dummy_argv[0] = (gchar*)"BBLplugin";

g_print("Ieeks, plugin_sensor_DL_runBBLclientORB, !!!!!!!!!!!!!!!!!!!\n");
return 0;
    // Read IOR file.
    //TODO: execute BBL if BBL aint ready...
    // define IOR file location 
    iorFile = g_string_new(getenv("HOME"));
    iorFile = g_string_append(iorFile, "/piper_info");
    mkdir(iorFile->str,S_IRWXU);
    iorFile = g_string_append(iorFile, "/ior");
    mkdir(iorFile->str,S_IRWXU);
    iorFile = g_string_append(iorFile, "/bl2pl.ior");
    // read ior file 
    ifp = fopen(iorFile->str,"r");
    if( ifp == NULL )
    {
        g_print("PL IOR file %s not found. ",iorFile->str);
        g_string_free(iorFile,TRUE);
        return 0;
    }
    fgets(filebuffer,1024,ifp);
    ior = g_strdup(filebuffer);
    //g_print("IOR = %s\n",ior);
    fclose(ifp);

    try {
        BL2PL_corba_orb = CORBA::ORB_init(dummy_argc, dummy_argv, "omniORB3");
        BL2PL_corba_object = BL2PL_corba_orb->string_to_object(ior);
        bl2plref = piper::BL2PL::PL::_narrow(BL2PL_corba_object);
        if( CORBA::is_nil(bl2plref) ) {
            cerr << "Cant narrow reference to type BL2PL (or it was nil).";

            return 0;
        } 
        BL2PL_corba_orb->run();
    }
    catch(CORBA::COMM_FAILURE& ex) {
        cerr << "Caught system exception COMM_FAILURE -- unable to contact the object ";
        return 0;
    }
    catch(CORBA::SystemException&) {
        cerr << "Caught a CORBA::SystemException.";
        return 0;
    }
    catch(CORBA::Exception&) {
        cerr << "Caught CORBA::Exception.";
        return 0;
    }
    catch(omniORB::fatalException& fe) {
        cerr << "Caught omniORB::fatalException:";
        cerr << "  file: " << fe.file() << endl;
        cerr << "  line: " << fe.line() << endl;
        cerr << "  mesg: " << fe.errmsg() << endl;
        return 0;
    }
    catch(...) {
        cerr << "Caught unknown exception.";
        return 0;
    }
    if (!bl2plref) {
        g_message("DFP cannot bind to %s", ior);
        return 0;
    }
    return 0;
}
*/

piper::DL2BL::uriListT* Obtain_i::programIds(void) {
    piper::DL2BL::uriListT* uril = new piper::DL2BL::uriListT(); 
    piper::DL2BL::statusS* status = new piper::DL2BL::statusS();
    guint i;
    guint length = 0;
    gchar* test_string;

    /* Request nodes list from PL's */
    //TODO

    /* Wait for answers of all PL's registred into DL's zone */
    //TODO

	/* allocate uriT sequence */
    length = Engine->secure_nodes(Engine->ENGINE_DL_ID,Engine->ENGINE_DL_PASSWORD->str);
    uril->length(length); 

    /* fill uriT sequence */
    for (i=0;i<length;i++) {
        (*uril)[i].instanceID = 1; /* BL instance */
        (*uril)[i].subnetID = Engine->secure_node_get_uri(Node,Engine->ENGINE_DL_ID,Engine->ENGINE_DL_PASSWORD->str)->subnetID;
        (*uril)[i].nodeID = 1;
        //TEMP REPLACED; (*uril)[i].description = description_retn();
        test_string = (gchar*)malloc(15);
        sprintf(test_string,"Unknown***%i",i);
        (*uril)[i].description = test_string;

        status = &(*uril)[i].status;
        status->progress = 0;
        piper::DL2BL::stateS* state = &(status->state);
        state->error = piper::DL2BL::ERRORUNKNOWN;
        state->constructed = TRUE;
        state->blocking = FALSE;
        state->temporary = FALSE;
        state->isolated = FALSE;
	}
	return uril;
}

CORBA::Boolean Obtain_i::uriIsAvailable(const piper::DL2BL::uriS &uri)
{
	CORBA::Boolean result = TRUE;
	return result;
}

// Connection Orb:
piper::DL2BL::processorS* Connection_i::setup(long int dlid,const char* password,const piper::DL2BL::connectionE connectiontype)
{
	piper::DL2BL::processorS* processor = new piper::DL2BL::processorS();
	// Check if DL is allowed to connect
	if (Engine->secure_register_dl(dlid,(gchar*)password,Engine->ENGINE_DL_ID,Engine->ENGINE_DL_PASSWORD->str)) {
	    //- get our Representation object to serve out and activate it
		CORBA::Object_var obj_repres = orb->resolve_initial_references("RootPOA");
		PortableServer::POA_var poa_repres = PortableServer::POA::_narrow(obj_repres);
		Representation_i* mainConn_repres = new Representation_i();
		PortableServer::ObjectId_var mainConnId_repres = poa_repres->activate_object(mainConn_repres);
		// get an object reference
		CORBA::Object_var objRef_repres = mainConn_repres->_this();
	    //- get our object to serve out and activate it
		CORBA::Object_var obj_obtain = orb->resolve_initial_references("RootPOA");
	    PortableServer::POA_var poa_obtain = PortableServer::POA::_narrow(obj_obtain);
	    Obtain_i* mainConn_obtain = new Obtain_i();
	    PortableServer::ObjectId_var mainConnId_obtain = poa_obtain->activate_object(mainConn_obtain);
		// get an object reference
		CORBA::Object_var objRef_obtain = mainConn_obtain->_this();
		//- Fill returned result:
		piper::DL2BL::Representation* repres = new piper::DL2BL::Representation();
		processor->representation = repres->_narrow(objRef_repres);
		piper::DL2BL::Obtain* obtain = new piper::DL2BL::Obtain();
		processor->obtain = obtain->_narrow(objRef_obtain);
		// Cleanup references
	    mainConn_repres->_remove_ref();
		mainConn_obtain->_remove_ref();
	} else {
        //raise(piper::DL2BL::IdInUse);
		// TODO: Not allowed, raise exception IdInUse
	}
	return processor;
}

CORBA::Boolean Connection_i::release(long int dlid,const char* password)
{
	CORBA::Boolean result = TRUE;
	if (Engine->secure_unregister_dl(dlid,(gchar*)password)) {
		g_log(PIPER_BL_LOG_DOMAIN,G_LOG_LEVEL_MESSAGE,"Removed DL client");
		result = TRUE;
	} else {
		g_log(PIPER_BL_LOG_DOMAIN,G_LOG_LEVEL_WARNING,"DL %li wasnt connected",dlid);
		result = FALSE;
	}
	return result;
}

piper::DL2BL::connectionE Connection_i::check(long int dlid)
{
	piper::DL2BL::connectionE result = piper::DL2BL::CONNUNKNOWN;
	return result;
}

CORBA::Boolean Connection_i::authorize(const char* password0,long int dlid,const char* password)
{
	CORBA::Boolean result = TRUE;
	return result;
}

CORBA::Boolean Connection_i::lockout(const char* password0,long int dlid,const char* password)
{
	CORBA::Boolean result = TRUE;
	return result;
}

piper::DL2BL::conflictE Connection_i::link(long int dlid,const char* password,const piper::DL2BL::uriS &parent_uri,const piper::DL2BL::uriS &child_uri)
{
	piper::DL2BL::conflictE result = piper::DL2BL::CONFUNKNOWN;
	return result;
}

/*
 * Sensor DL plugin implementation:
 */

gboolean sensor_DL_procedure() {
    /* Notify DL of incoming event */
    //TODO: Implement DL notify Corba API
    g_log(PIPER_BL_LOG_DOMAIN,G_LOG_LEVEL_WARNING,"PL execution done, DL notification API UNIMPLEMENTED");
    /* reset procedure_running */
    Engine->secure_node_set_procedure_running(Node,FALSE,Engine->ENGINE_DL_ID,Engine->ENGINE_DL_PASSWORD->str);
    return TRUE;
}

gboolean sensor_DL_cleanup() {
    /* dummy, nothing to do */
    /* reset procedure_running */
    Engine->secure_node_set_procedure_running(Node,FALSE,Engine->ENGINE_DL_ID,Engine->ENGINE_DL_PASSWORD->str);
    return TRUE;
}

gboolean sensor_DL_activate() {
    // TODO : implement actual code
	return TRUE;
}

gpointer plugin_sensor_DL_init_threaded(gpointer data) {
    int dummy_argc = 1;
    gchar *dummy_argv[1];
    GString* iorFile;
    dummy_argv[0] = "plugin_sensor_DL";

    try {
        // start up the ORB and POA
        orb = CORBA::ORB_init(dummy_argc, dummy_argv, "omniORB3");
        CORBA::Object_var obj = orb->resolve_initial_references("RootPOA");
        poa = PortableServer::POA::_narrow(obj);
        // get our object to serve out and activate it
        Connection_i* mainConn = new Connection_i();
        PortableServer::ObjectId_var mainConnId = poa->activate_object(mainConn);
        // get an object reference and write the IOR to a file
        CORBA::Object_var objRef = mainConn->_this();
        CORBA::String_var stringIor(orb->object_to_string(objRef));
        /* define IOR file location */
        iorFile = g_string_new(getenv("HOME"));
        iorFile = g_string_append(iorFile, "/piper_info");
        mkdir(iorFile->str,S_IRWXU);
        iorFile = g_string_append(iorFile, "/ior");
        mkdir(iorFile->str,S_IRWXU);
        // TODO: make possible to have unlimited nr. of ior so multiple DL's can run at once
        iorFile = g_string_append(iorFile, "/dl2bl.ior");
        ofstream outStream;
        outStream.open(iorFile->str);
        outStream << stringIor;
        outStream.close();
        // only the POA holds a reference to the connection interface now
        mainConn->_remove_ref();
        // Activate the POA manager and run the orb
        PortableServer::POAManager_var pMan = poa->the_POAManager();
        pMan->activate();
        // Start Orb inside a thread
		orb->run();
		orb->destroy();
	}
    catch(CORBA::SystemException&) {
        cerr << "Caught a CORBA::SystemException." << endl;
    }
    catch(CORBA::Exception&) {
        cerr << "Caught a CORBA::Exception." << endl;
    }
    catch(omniORB::fatalException& fe) {
        cerr << "Caught an omniORB::fatalExecption:" << endl;
        cerr << "  file: " << fe.file() << endl;
        cerr << "  line: " << fe.line() << endl;
        cerr << "  mseg: " << fe.errmsg() << endl;
    }
    catch(...) {
        cerr << "Caught an unknown exception." << endl;
    }
	return 0;
}

gboolean sensor_DL_init(glong NodeID,engine *_Engine) {
    Engine = _Engine;
    Node = NodeID;
    Data = Engine->secure_node_get_data(Node,Engine->ENGINE_DL_ID,Engine->ENGINE_DL_PASSWORD->str);

//g_print("Sensor dname = %s, NodeID = %i\n",Engine->secure_node_get_dname(Node,Engine->ENGINE_DL_ID,Engine->ENGINE_DL_PASSWORD->str)->str,Node);
//g_print("sensor_DL_description = %s\n",sensor_DL_description());

	// Start Server Orb :
    //g_print("Started sensor_DL_init\n");
	DLthread = pthread_create(&DLtree,NULL,plugin_sensor_DL_init_threaded,NULL);
    //g_print("Started sensor_DL_init thread\n");
	return TRUE;
}

#define PLUGIN_DL_NAME_SENSOR "DL plugin sensor"
#define PLUGIN_DL_NAME_COLLECTOR "DL plugin collector"
#define PLUGIN_DL_DESCRIPTION "Collects and handles DL XML streams"
#define PLUGIN_DL_SENSOR_DESCRIPTION "DL plugin sensor"
#define PLUGIN_DL_COLLECTOR_DESCRIPTION "DL plugin collector"

const gchar* sensor_DL_name() {
    return "DL plugin sensor";
}

const gchar* sensor_DL_description() {
    return "Collects and handles DL XML streams";
}

nodeType_t sensor_DL_nodetype() {
    return (nodeType_t)SensorNode;
}

