/*
 * DL sensor, Jarl van Katwijk, 1-11-2000,
 *
 */

#ifndef SENSOR_DL
#define SENSOR_DL

#include "messaging_plugin.h"
#include "DL2BL.hh"

/* proto's */
gboolean sensor_DL_procedure();
gboolean sensor_DL_cleanup();
gboolean sensor_DL_activate();
gboolean sensor_DL_init(glong Node,engine* Engine);
const gchar* sensor_DL_name();
const gchar* sensor_DL_description();
nodeType_t sensor_DL_nodetype();



/* - Auto plugin registration code -------------------------------*/

extern "C" {
    plugin_maker* maker_sensor_DL(){
        plugin_maker *plug = (plugin_maker*)g_malloc(sizeof(plugin_maker));
        plug->procedure = sensor_DL_procedure;
        plug->cleanup   = sensor_DL_cleanup;
        plug->activate  = sensor_DL_activate;
        (gpointer)plug->init      = sensor_DL_init;
        plug->name      = sensor_DL_name;
        plug->description = sensor_DL_description;
        plug->nodetype = sensor_DL_nodetype;
        return plug;
    }

    class proxy {
        public:
            proxy() {
                /* fill in plugin info */
                BL_plugins["sensor_DL"] = maker_sensor_DL;
                /* register this plugin to plugins list */
                g_log(PIPER_BL_LOG_DOMAIN,G_LOG_LEVEL_DEBUG,"Registered sensor_DL");
            }
    };

    // our one instance of the proxy
    proxy p;
}

// Corba ORB class
class Representation_i : public POA_piper::DL2BL::Representation,
                         public PortableServer::RefCountServantBase {
    public: 
        inline Representation_i() {
        }
        virtual ~Representation_i() {}
        /* Functionality */
        virtual piper::DL2BL::uriS* upload(const char* xmldocument,long int dlid,const char* password);
        virtual char * download(const piper::DL2BL::uriS &uri,long int dlid,const char* password);
        virtual CORBA::Boolean update(const char *xmldocument,const piper::DL2BL::uriS &uri,long int dlid,const char* password);
};

class Obtain_i : public POA_piper::DL2BL::Obtain,
                 public PortableServer::RefCountServantBase {
    public:
        inline Obtain_i() {
        }
        /* Functionality */
        virtual ~Obtain_i() {}

        virtual piper::DL2BL::statusS uriStatus(const piper::DL2BL::uriS &uri,long int dlid,const char* password);
        virtual char * uriInfo(const char* password,const piper::DL2BL::uriS &uri);
        virtual piper::DL2BL::uriListT* programIds();
        virtual CORBA::Boolean uriIsAvailable(const piper::DL2BL::uriS &uri);
};

class Connection_i : public POA_piper::DL2BL::Connection,
                     public PortableServer::RefCountServantBase {
    public:
        inline Connection_i() {
        }
        virtual ~Connection_i() {}
        /* Functionality */
        virtual piper::DL2BL::processorS* setup(long int dlid,const char* password,const piper::DL2BL::connectionE connectiontype);
        virtual CORBA::Boolean release(long int dlid,const char* password);
        virtual piper::DL2BL::connectionE check(long int dlid);
        virtual CORBA::Boolean authorize(const char* password0,long int dlid,const char* password);
        virtual CORBA::Boolean lockout(const char* password0,long int dlid,const char* password);
        virtual piper::DL2BL::conflictE link(long int dlid,const char* password,const piper::DL2BL::uriS &parent_uri,const piper::DL2BL::uriS &child_uri);
};

#endif


