/*
 * PL sensor, Jarl van Katwijk, 1-11-2000,
 *
 * 26-02-2001, jarl van katwijk, converted code to BL 0.5 OOP model
 *
 */

#ifndef SENSOR_PL
#define SENSOR_PL

#include "messaging_plugin.h"

/* proto's */
gboolean sensor_PL_procedure();
gboolean sensor_PL_cleanup();
gboolean sensor_PL_activate();
gboolean sensor_PL_init(glong Node,engine *Engine);
const gchar* sensor_PL_name();
const gchar* sensor_PL_description();
nodeType_t sensor_PL_nodetype();


/* - Auto plugin registration code -------------------------------*/

extern "C" {
    plugin_maker* maker_sensor_PL(){
        plugin_maker *plug = (plugin_maker*)g_malloc(sizeof(plugin_maker));
        plug->procedure = sensor_PL_procedure;
        plug->cleanup   = sensor_PL_cleanup;
        plug->activate  = sensor_PL_activate;
        (gpointer)plug->init      = sensor_PL_init;
        plug->name      = sensor_PL_name;
        plug->description = sensor_PL_description;
        plug->nodetype = sensor_PL_nodetype;
        return plug;
    }

    class proxy {
        public:
            proxy() {
                /* fill in plugin info */
                BL_plugins["sensor_PL"] = maker_sensor_PL;
                /* register this plugin to plugins list */
                g_log(PIPER_BL_LOG_DOMAIN,G_LOG_LEVEL_DEBUG,"Registered sensor_PL");
            }
    };

    // our one instance of the proxy
    proxy p;
}

#endif
