/*
 * Localhost sensor, bastardAI 31-8-1999,
 * 	collects various info of the localhost
 *
 * -------------------------------------------------------------------
 * -*- Mode: C; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 2 -*-
 *   guname: System information dialog.
 *
 *   Copyright (C) 1998 Havoc Pennington <hp@pobox.com> except marquee code.
 *
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License as 
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 */

#ifndef SENSOR_LOCALHOST
#define SENSOR_LOCALHOST

#include "messaging_plugin.h"

/* proto's */
gboolean sensor_localhost_procedure();
gboolean sensor_localhost_cleanup();
gboolean sensor_localhost_activate();
gboolean sensor_localhost_init(glong Node,engine *Engine);
const gchar* sensor_localhost_name();
const gchar* sensor_localhost_description();
nodeType_t sensor_localhost_nodetype();


/* The basic information to display in the main dialog. */
typedef enum {
  si_distribution, /* Debian, Solaris, etc. */
  si_OS,     
  si_distribution_version, 
  si_OS_version,
  si_release,

  si_CPU_type,
  si_CPU_speed,

  si_host,
  si_domain,

  si_user,
  si_display,

  si_uptime,

  si_mem,          
  si_mem_swap,
  si_mem_total,     
  si_mem_total_free,

  end_system_info
} system_info;

/* - Auto plugin registration code -------------------------------*/

extern "C" {
    plugin_maker* maker_sensor_localhost(){
        plugin_maker *plug = (plugin_maker*)g_malloc(sizeof(plugin_maker));
        plug->procedure = sensor_localhost_procedure;
        plug->cleanup   = sensor_localhost_cleanup;
        plug->activate  = sensor_localhost_activate;
        (gpointer)plug->init      = sensor_localhost_init;
        plug->name      = sensor_localhost_name;
        plug->description = sensor_localhost_description;
        plug->nodetype = sensor_localhost_nodetype;
        return plug;
    }

    class proxy {
        public:
            proxy() {
                /* fill in plugin info */
                BL_plugins["sensor_localhost"] = maker_sensor_localhost;
                /* register this plugin to plugins list */
                g_log(PIPER_BL_LOG_DOMAIN,G_LOG_LEVEL_DEBUG,"Registered sensor_localhost");
            }
    };

    // our one instance of the proxy
    proxy p;
}

#endif


