#ifndef VISUAL_DEVEL
#define VISUAL_DEVEL

#include "messaging_plugin.h"

/* proto's */
gboolean visual_devel_procedure();
gboolean visual_devel_cleanup();
gboolean visual_devel_activate();
gboolean visual_devel_init(glong Node,engine *Engine);
const gchar* visual_devel_name();
const gchar* visual_devel_description();
nodeType_t visual_devel_nodetype();

/* - Auto plugin registration code -------------------------------*/

extern "C" {
    plugin_maker* maker_visual_devel(){
        plugin_maker *plug = (plugin_maker*)g_malloc(sizeof(plugin_maker));
        plug->procedure = visual_devel_procedure;
        plug->cleanup   = visual_devel_cleanup;
        plug->activate  = visual_devel_activate;
        (gpointer)plug->init      = visual_devel_init;
        plug->name      = visual_devel_name;
        plug->description = visual_devel_description;
        plug->nodetype  = visual_devel_nodetype;
        return plug;
    }


    class proxy {
        public:
            proxy() {
                /* fill in plugin info */
                BL_plugins["visual_devel"] = maker_visual_devel;
                /* register this plugin to plugins list */
                g_log(PIPER_BL_LOG_DOMAIN,G_LOG_LEVEL_DEBUG,"Registered visual_devel");
            }
    };

    // our one instance of the proxy
    proxy p;
}

#endif
