
#ifndef VISUAL_LOCALHOST
#define VISUAL_LOCALHOST

#include "messaging_plugin.h"

/* proto's */
gboolean visual_localhost_procedure();
gboolean visual_localhost_cleanup();
gboolean visual_localhost_activate();
gboolean visual_localhost_init(glong Node,engine *Engine);
const gchar* visual_localhost_name();
const gchar* visual_localhost_description();
nodeType_t visual_localhost_nodetype();


/* The basic information to display in the main dialog. */
typedef enum {
  si_distribution, /* Debian, Solaris, etc. */
  si_OS,
  si_distribution_version,
  si_OS_version,
  si_release,

  si_CPU_type,
  si_CPU_speed,

  si_host,
  si_domain,

  si_user,
  si_display,

  si_uptime,

  si_mem,
  si_mem_swap,
  si_mem_total,
  si_mem_total_free,

  end_system_info
} system_info;


/* - Auto plugin registration code -------------------------------*/

extern "C" {
    plugin_maker* maker_visual_localhost(){
        plugin_maker *plug = (plugin_maker*)g_malloc(sizeof(plugin_maker));
        plug->procedure = visual_localhost_procedure;
        plug->cleanup   = visual_localhost_cleanup;
        plug->activate  = visual_localhost_activate;
        (gpointer)plug->init      = visual_localhost_init;
        plug->name      = visual_localhost_name;
        plug->description = visual_localhost_description;
        plug->nodetype  = visual_localhost_nodetype;
        return plug;
    }

    class proxy {
        public:
            proxy() {
                /* fill in plugin info */
                BL_plugins["visual_localhost"] = maker_visual_localhost;
                /* register this plugin to plugins list */
                g_log(PIPER_BL_LOG_DOMAIN,G_LOG_LEVEL_DEBUG,"Registered visual_localhost");
            }
    };

    // our one instance of the proxy
    proxy p;
}

#endif

