
#ifndef VISUAL_STATUSBAR
#define VISUAL_STATUSBAR

#include "messaging_plugin.h"

/* various internal functions */
extern gint context_id1;
extern gint context_id2;
extern gint context_id3;
extern gint context_id4;
extern gint context_id5;
extern gint context_id6;
extern gint context_id7;
extern gint context_id8;

/* proto's */
gboolean visual_statusbar_procedure();
gboolean visual_statusbar_cleanup();
gboolean visual_statusbar_activate();
gboolean visual_statusbar_init(glong Node,engine *Engine);
const gchar* visual_statusbar_name();
const gchar* visual_statusbar_description();
nodeType_t visual_statusbar_nodetype();

/* - Auto plugin registration code -------------------------------*/

extern "C" {
    plugin_maker* maker_visual_statusbar(){
        plugin_maker *plug = (plugin_maker*)g_malloc(sizeof(plugin_maker));
        plug->procedure = visual_statusbar_procedure;
        plug->cleanup   = visual_statusbar_cleanup;
        plug->activate  = visual_statusbar_activate;
        (gpointer)plug->init      = visual_statusbar_init;
        plug->name      = visual_statusbar_name;
        plug->description = visual_statusbar_description;
        plug->nodetype  = visual_statusbar_nodetype;
        return plug;
    }

    class proxy {
        public:
            proxy() {
                /* fill in plugin info */
                BL_plugins["visual_statusbar"] = maker_visual_statusbar;
                /* register this plugin to plugins list */
                g_log(PIPER_BL_LOG_DOMAIN,G_LOG_LEVEL_DEBUG,"Registered visual_statusbar");
            }
    };

    // our one instance of the proxy
    proxy p;
}

#endif

