/*
 *  BL2, completly rewritten BL Piper compliant,
 *  based on BL, which was a rewrite of the
 *  gMessaging System
 *
 *  Copyleft (-) 1999,2000,2001  Jarl van Katwijk
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *  begin : unknown, BastardAI
 *  
 *  21-6-1999: added background awareness to applet
 *             removed some old code
 *             started db code 
 *  07-7-1999: background replaced by an animation, lacks goods graphs
 *             rewrote structure, streams are added by the db now
 *             UI is frozen
 *             messaging objects defined, not final
 *             a compiler no-warning policy :)
 *  28-7-1999: next devel phase done: new streams are configured by the user
 *			   added localhost info, code taken out "guname" (gutils 1.01),
 *			   All MO's list added, build 2nd visual: animated applet,
 *			   various UI changes, changed project titel from gMessaging System
 *			   to GNU Messaging System.
 *  04-8-1999: reorganised source filenames, done much UI functionality past days
 *
 */


/*
 * INCLUDES
 *
 */
#include "messaging_config.h"
#include "messaging.h"
#include "messaging_engine.h"
#include <sys/stat.h>
#include <sys/types.h>
#include <fcntl.h>
#include <unistd.h>
#include <malloc.h>
#include <signal.h>
#include <gdk/gdkkeysyms.h>
#ifdef HAVE_CONFIG_H
#  include "config.h"
#endif

/*
 * GLOBALS
 */
engine *Engine; /* BL needs to have at least it's local area */
map <string, maker_ptr*,less<string> > BL_plugins; /* Plugin list, filled with struct BL_plugin */


/*
 * FUNCTIONS...
 *
 */

void fatal_error_signal(GtkObject *object,gpointer user_data) {
    /* TODO: this need to be removed after engine destructor takes care of everything */
	/* Now do the clean up actions:
	 - reset terminal modes
	 - kill child processes
	 - remove lock files */
	//disabled; messaging_debug_destruct();
	return;
}


void messaging_destruct(int sig) {
    delete Engine;
    return;
}


int main(int argc, char **argv) {

    /* Display app name and version */
    g_message("Piper BL GMS %s",VERSION_STRING);

    /* Hook signals */
    signal(SIGTERM,messaging_destruct);
    //disabled while being unstable; signal(SIGSEGV,messaging_db_destruct);
    signal(SIGINT,messaging_destruct);

    /* init gtk */
    gtk_init (&argc, &argv);

    /* Allocate the local engine,
       The constructor makes it run, and allocate all needed classes,
       also loads all available plugins, creates 1st local area
    */
    Engine = new engine(1,1,"LocalZone");

    return 0;
}
