#include <glib.h>
#include "messaging_admin.h"


CORBA::Boolean ADMDFP_i::dbMATCHregexp(const char* ST1, const char* ST2,CORBA::Long DLid,const char* Password) {
    (CORBA::Boolean)Engine->regexpmatch((gchar*)ST1,(gchar*)ST2);
}

CORBA::Long ADMDFP_i::dbRELATEbyname(const char* searchstring, glong node,CORBA::Long DLid,const char* Password) {
    return (CORBA::Long)Engine->area::secure_relate_node_to_dname(node,(gchar*)searchstring,DLid,(gchar*)Password);
}

CORBA::Long ADMDFP_i::dbRELEASEbyname(const char* searchstring, glong node,CORBA::Long DLid,const char* Password) {
    return (CORBA::Long)Engine->unrelate_by_name((gchar*)searchstring,Engine->get_node(node));
}

CORBA::Long ADMDFP_i::dbRELATEbyfilter(const char* searchstring, glong node,CORBA::Long DLid,const char* Password) {
    return (CORBA::Long)Engine->relate_by_filter((gchar*)searchstring,Engine->get_node(node));
}

CORBA::Long ADMDFP_i::dbRELATEbymo(glong parent_node,glong child_node,CORBA::Long DLid,const char* Password) {
        return (CORBA::Long)Engine->relate_by_node(Engine->get_node(parent_node),Engine->get_node(child_node));
}

CORBA::Boolean ADMDFP_i::dbSETpipeline(glong Node,CORBA::Long DLid,const char* Password) {
    return (CORBA::Boolean)Engine->pipeline_in(Engine->get_node(Node));
}

CORBA::Boolean ADMDFP_i::dbREGISTERadm(glong clientID) {
    Engine->lock("impl_ADMDFP_dbREGISTERadm");
    /* reset deadenddialog status */
    Engine->deadendstream_active = FALSE;
    /* lock pipeline */
    Engine->shuttingdown = TRUE;
    gtk_timeout_add(2500,engine_bind2DL_timeout,Engine);
	//g_print("Added timeout for Admin client bootup\n");
    return (Engine->registerDL(CLIENT_ID,CLIENT_PASSWORD,CLIENT_ID,CLIENT_PASSWORD));
}

CORBA::Boolean ADMDFP_i::dbUNREGISTERadm(glong clientID) {
	node *NODE_LIST;
    GList *element;

    // TODO : Work out visuals & docking better
    // Engine->locknunlock("impl_ADMDFP_dbUNREGISTERadm");
    // element = Engine->area->NODE_LLIST;
    // while (element != NULL)
    // {
    //     NODE_LIST = (node*)element->data;
    //     if (NODE_LIST->moType==VisualNode)
    //     {
    //         NODE_LIST->UIsetup = FALSE;
    //         NODE_LIST->status = Blocking;
    //     }
	// 	element = g_list_next(element);
    // }
    /* reset deadenddialog status */
    Engine->deadendstream_active = FALSE;
    /* unbind to DL corba server.. */
    Engine->lock("impl_ADMDFP_dbUNREGISTERadm");
    gtk_timeout_add(100,engine_bind2DL_timeout,NULL);
    return (Engine->unregisterDL(CLIENT_ID,CLIENT_PASSWORD));
}

CORBA::Boolean ADMDFP_i::dbLOADplugins() {
    return (Engine->load_plugins());
}

CORBA::Boolean ADMDFP_i::dbREGISTERvisualpanels() {
	node *NODE_LIST;
    GList *element;

    // TODO: work out visuals & docking better
    // /* request output panels on DL for the visuals */
    // element = NODE_LLIST;
    // while (element->next != NULL) {
    //     NODE_LIST = (node*)element->data;
    //     if (NODE_LIST!=NULL)
    //         if (NODE_LIST->moType == VisualNode) {
    //             if (strcmp(NODE_LIST->dname->str,"visual APPLET Node")==0) {
    //                /* dock special visual alarm into DL */
    //                 (void)(NODE_LIST->visualPlug_buildProcedure)(Node_LIST,0);
    //                 NODE_LIST->UIsetup = TRUE;
    //                 NODE_LIST->status = Passing;
    //             } else
    //                 if (strcmp(NODE_LIST->dname->str,"visual STATUSBAR Node")==0) {
    //                    /* dock special visual statusbar into DL */
    //                     (void)(NODE_LIST->visualPlug_buildProcedure)(NODE_LIST,0);
    //                     NODE_LIST->UIsetup = TRUE;
    //                     NODE_LIST->status = Passing;
    //                 } else
    //                     (void)messaging_db_registerPLUGIN2DL(NODE_LIST);
    //         }
    //     element = g_list_next(element);
    // }
    Engine->shuttingdown = FALSE;
    return FALSE;
}

void ADMDFP_i::dbDEADENDDIALOGclosed() {
    Engine->deadendstream_active = FALSE;
    return;
}

CORBA::Long ADMDFP_i::mobjectNEW(const gchar* dname,const gchar* description,glong motype,glong init) {
    glong NODE_temp;
    NODE_temp = Engine->node_new((gchar*)dname,(gchar*)description,(moType_t)motype);
    return((CORBA::Long)NODE_temp);
}

CORBA::Boolean ADMDFP_i::mobjectDESTRUCT(glong Node) {
    gboolean result;
    result = Engine->node_delete(Node);
    return (result);
}

CORBA::Boolean ADMDFP_i::mobjectDESTRUCTplug(glong NODE) {
/*	node* NODE_temp;
    Node_temp = NodeREF2Node(NODE);
    if (Node_temp!=NULL)
         return TRUE;
*/
    return FALSE;
}

CORBA::Long ADMDFP_i::mobjectCALLinit(glong NODE) {
/*    node* NODE_temp;
    NODE_temp = NodeREF2Node(NODE);
    if (NODE_temp!=NULL)
         return (NODE_temp->init(NULL));
*/
    return 0;
}

CORBA::Long ADMDFP_i::mobjectCALLdestruct(glong NODE) {
/*	node* NODE_temp;
    NODE_temp = NodeREF2Node(NODE);
    if (NODE_temp!=NULL)
        delete NODE_temp;
*/
    return 0;
}

CORBA::Long ADMDFP_i::mobjectCALLconfigplugbuildprocedure(glong NODE,glong XID) {
/*    node* NODE_temp;
    NODE_temp = NodeREF2Node(NODE);
    if ((NODE_temp!=NULL)&&(XID!=0))
        return (CORBA::Long)NODE_temp->configPlug_buildProcedure(NODE_temp,XID);
*/
    return 0;
}

gchar* ADMDFP_i::mobjectGETCHARmotype(glong Node) {
    moType_t type = Engine->node_get_type(Node);
    return (CORBA::string_dup)((gchar*)Engine->motype_to_char(type));
}

char * ADMDFP_i::mobjectGETCHARstatus(glong Node) {
    statusType_t status = Engine->node_get_status(Node);
    return (CORBA::string_dup)(Engine->status_to_char(status));
}

CORBA::Long ADMDFP_i::mobjectGETrelation(glong Node,glong relation) {
    return (CORBA::Long)(Engine->node_get_relation(Node,relation));
}

char * ADMDFP_i::mobjectGETdname(glong Node) {
    return (CORBA::string_dup)((Engine->node_get_dname(Node))->str);
}

char * ADMDFP_i::mobjectGETdescription(glong Node) {
    return (CORBA::string_dup)((Engine->node_get_description(Node))->str);
}

char * ADMDFP_i::mobjectGETallowedfilter(glong Node) {
    return (CORBA::string_dup)((Engine->node_get_allowedfilter(Node))->str);
}

char * ADMDFP_i::mobjectGETdatadescription(glong Node) {
    return (CORBA::string_dup)((Engine->node_get_datadescription(Node))->str);
}

CORBA::Long ADMDFP_i::mobjectGETname(glong Node) {
    return (CORBA::Long)(Engine->node_get_name(Node));
}

CORBA::Long ADMDFP_i::mobjectGETmotype(glong Node) {
    return (CORBA::Long)(Engine->node_get_type(Node));
}

CORBA::Long ADMDFP_i::mobjectGETstatus(glong Node) {
    return (CORBA::Long)(Engine->node_get_status(Node));
}

CORBA::Long ADMDFP_i::mobjectGETcurrentrelations(glong Node) {
    return (CORBA::Long)(Engine->node_get_currentrelations(Node));
}

CORBA::Long ADMDFP_i::mobjectGETvisualsocket(glong Node) {
    return 0;
}

CORBA::Long ADMDFP_i::mobjectGETconfigplugbuildprocedure(glong Node) {
/*    node* Node_temp;
    Node_temp = NodeREF2Node(Node);
    if (Node_temp!=NULL)
        return (CORBA::Long)Node_temp->configPlug_buildProcedure;
*/
    return 0;
}

char * ADMDFP_i::mobjectGETconfigruntime(glong Node) {
/*    node* Node_temp;
    Node_temp = NodeREF2Node(Node);
    if (Node_temp!=NULL)
        return (CORBA::string_dup)((gchar*)Node_temp->configRuntime);
*/    return (CORBA::string_dup)((gchar*)(""));
}

CORBA::Long ADMDFP_i::mobjectGETrawdatalen(glong Node) {
/*    node* Node_temp;
    Node_temp = NodeREF2Node(Node);
    if (Node_temp!=NULL)
        return (CORBA::Long)Node_temp->Data->rawdataLen;
*/    return (CORBA::Long)NULL;
}

CORBA::Long ADMDFP_i::mobjectGETdata(glong Node) {
    return (CORBA::Long)(Engine->node_get_data(Node));
}

CORBA::Long ADMDFP_i::mobjectGETplug(glong Node) {
    return (CORBA::Long)NULL;
}

CORBA::Long ADMDFP_i::mobjectGETnrObjects() {
    return (CORBA::Long)(Engine->nodes());
}

CORBA::Long ADMDFP_i::mobjectGETnthObjectREF(glong NR) {
/*    if (g_list_nth(Node_LLIST,NR) != NULL)
        Node = (node*)g_list_nth(Node_LLIST,NR)->data;
    if (Node == NULL)
        return -1;
    else
        return Node->uri->subnetID;
*/
	return -1;
}

CORBA::Boolean ADMDFP_i::mobjectSETstatus(glong Node,glong status) {
    gboolean result;
    result = Engine->node_set_status(Node,(statusType_t)status);
    return (CORBA::Boolean)result;
}

CORBA::Boolean ADMDFP_i::mobjectSETconfigplug(glong Node,glong configplug) {
/*    node* Node_temp;
    Node_temp = NodeREF2Node(Node);
    if (Node_temp!=NULL) {
        //Node_temp->configPlug = (gpointer)configplug;
        // TODO: have a 2nd look 
        return (CORBA::Boolean)TRUE;
    }
*/    return (CORBA::Boolean)FALSE;
}

CORBA::Boolean ADMDFP_i::mobjectSETvisualplug(glong Node,glong visualplug) {
    return FALSE;
}

CORBA::Boolean ADMDFP_i::mobjectSETconfigruntime(glong Node,const char* runtime) {
/*    node* Node_temp;
    Node_temp = NodeREF2Node(Node);
    if (Node_temp!=NULL) {
        g_memmove(Node_temp->configRuntime,runtime,strlen(runtime));
        return (CORBA::Boolean)TRUE;
    }
*/    return (CORBA::Boolean)FALSE;
}

CORBA::Boolean ADMDFP_i::mobjectSETdname(glong Node,const char* text) {
    gboolean result;
    result = Engine->node_set_dname(Node,(gchar*)text);
    return (CORBA::Boolean)result;
}

CORBA::Boolean ADMDFP_i::mobjectSETdescription(glong Node,const char* text) {
    gboolean result;
    result = Engine->node_set_description(Node,(gchar*)text);
    return (CORBA::Boolean)result;
}

CORBA::Boolean ADMDFP_i::mobjectSETdatadescription(glong Node,const char* text) {
    gboolean result;
    result = Engine->node_set_datadescription(Node,(gchar*)text);
    return (CORBA::Boolean)result;
}

CORBA::Boolean ADMDFP_i::mobjectSETmotype(glong Node,glong motype) {
    gboolean result;
    result = Engine->node_set_motype(Node,(moType_t)motype);
    return (CORBA::Boolean)result;
}

CORBA::Boolean ADMDFP_i::mobjectSETallowedfilter(glong Node,const char* filter) {
    gboolean result;
    result = Engine->node_set_allowedfilter(Node,(gchar*)filter);
    return (CORBA::Boolean)result;
}

CORBA::Long ADMDFP_i::dataobjectNEW(glong Data,glong rawmemlen) {
    return (CORBA::Long)(Engine->data_new(Data,rawmemlen));
}

CORBA::Boolean ADMDFP_i::dataobjectDESTRUCT(glong Data) {
    return (CORBA::Boolean)(Engine->data_delete(Data));
}
CORBA::Boolean ADMDFP_i::dataobjectDUPLICATE(glong Destination,glong Source) {
    return (CORBA::Boolean)Engine->data_copy(Destination,Source);
}

char * ADMDFP_i::dataobjectGETCHARrawdata(glong Data) {
    return (CORBA::string_dup)((gchar*)(Engine->data_get_rawdata(Data)));
}

CORBA::Long ADMDFP_i::dataobjectGETrawdatalen(glong Data) {
    return (CORBA::Long)(Engine->data_get_rawlen(Data));
}

char * ADMDFP_i::dataobjectGETstring(glong Data) {
    return (CORBA::string_dup)(Engine->data_get_string(Data));
}

CORBA::Long ADMDFP_i::dataobjectGETinteger(glong Data) {
    return (CORBA::Long)(Engine->data_get_integer(Data));
}

CORBA::Long ADMDFP_i::dataobjectGETpercentage(glong Data) {
    return (CORBA::Long)(Engine->data_get_percentage(Data));
}

CORBA::Boolean ADMDFP_i::dataobjectGETboolean(glong Data) {
    return (CORBA::Boolean)(Engine->data_get_boolean(Data));
}

CORBA::Boolean ADMDFP_i::dataobjectSETrawdata(glong Data,const char* data,glong len) {
    gboolean result;
    result = Engine->data_set_rawdata(Data,(gchar*)data,len);
    return (CORBA::Boolean)result;
}

