#include "messaging_data.h"

gboolean data::data_copy(data *Destination,data *Source) {
    if (Source->ID == Destination->ID) {
        g_log(PIPER_BL_LOG_DOMAIN,G_LOG_LEVEL_WARNING,"Destination is Source Data Block (ID=%li), copy cancelled",Source->ID);
        return FALSE;
    }

    /* Copy mdo to another mdo. Note that the Data ID is not copied  */
    g_string_sprintf(Destination->datadescription,"%s",Source->datadescription->str);
    g_memmove(Destination->rawdata,Source->rawdata,Source->rawdatalen);
    g_string_sprintf(Destination->string,"%s",Source->string->str);
    Destination->integer = Source->integer;
    Destination->percentage = Source->percentage;
    Destination->boolean = Source->boolean;
    Destination->originatorID = Source->originatorID;

    return TRUE;
}

gboolean data::typecast(data* Data_obj) {
    /* Here data is normalised; It transforms data into the format the receipient wants
       It's called by pipeline_in. Data format types (so far) :
            String      : like the C stings
            Integer     : like C type int
            Percentage  : c type int, but ranging from 0 to 100
            Boolean     : c type int, but only TRUE or FALSE
            Unique      : some special structure, never adjusted
    */

    /* TODO : to-string must be more flexible */


    if (strlen((char*)Data_obj->rawdata)>0)
        g_string_sprintf(Data_obj->string,"%s",(gchar*)Data_obj->rawdata); /* to string */
    else
        g_string_sprintf(Data_obj->string,"%s","");
    Data_obj->integer = atoi((char*)Data_obj->string); /* to integer */
    Data_obj->percentage = Data_obj->integer; /* to percentage */
    if (Data_obj->percentage>100)
        Data_obj->percentage = -(Data_obj->percentage);
    Data_obj->boolean = (Data_obj->string->len>0); /* to boolean */
    //nop; /* format is undefined\unique, no conversion */
    return TRUE;
}

