#include "messaging_legacy.h"
#include "messaging_config.h"
#include <unistd.h>

guint linenr = 1;

gboolean legacy::historyIO_create(void) {
    /* Create directory for history file */
    GString *dir;

    /* TODO: better GIOChannel checking */

    return TRUE;
}

gboolean legacy::historyIO_open(node *Node) {
    /* Open history file for Node */
    /* TODO: add gzip\pgp pipeing */
    gint fd,i;
    struct dirent **libsdir;

    /* Check\create history directory */
    if (historyIO_create() == FALSE) {
        g_log(PIPER_BL_LOG_DOMAIN,G_LOG_LEVEL_ERROR,"Error during creation of historyIO path");
        return FALSE;
    }

    /* Create file */
    Node->historyFilename = g_string_new("");
    g_string_sprintf(Node->historyFilename,"%s%s%s%s",getenv("HOME"),"/piper_info/history/",Node->dname->str,".history");
    fd = open(Node->historyFilename->str,O_RDWR | O_CREAT | O_APPEND,S_IRWXU);

    /* Error handling */
    if (fd == -1) {
        g_log(PIPER_BL_LOG_DOMAIN,G_LOG_LEVEL_ERROR,"%i during file CREATE|APPEND",errno);
        return FALSE;
    }

    /* Link opened file to a g_io_channel */
    Node->historyIO = g_io_channel_unix_new(fd);

    return TRUE;
}

gboolean legacy::historyIO_close(node *Node) {
    /* Close history file */
    /* TODO: add gzip\pgp pipeing */
    /* TODO: better GIOChannel checking */

    /* Does channel exist at all? */
    if (Node->historyIO == NULL)
        return FALSE;

    /* Is channel valid? */
    if (g_io_channel_unix_get_fd(Node->historyIO)>0)
        return FALSE;

    /* Close channel */
    close(g_io_channel_unix_get_fd(Node->historyIO));
    Node->historyIO = NULL;

    return TRUE;
}

glong legacy::historyIO_write(node* Node) {
    guint bytes_written;

    /* write Data of Node to history file */
    g_io_channel_write( Node->historyIO,
                        (gchar*)Node->Data,
                        (guint)sizeof(data),
                        &bytes_written
    );

    /* Check write */
    if (bytes_written != sizeof(data)) {
        g_log(PIPER_BL_LOG_DOMAIN,G_LOG_LEVEL_WARNING,"Wrote incorrect number of byte to historyIO from %s\n",Node->dname->str);
        return -1;
    }

    return bytes_written;
}

guint legacy::load_record(GIOChannel *loadfile,gchar *data,gint count, gchar* label) {
    /* loads a record from savefile */
    /* RecordLen [sizeof(gint):4] \ Data [RecordLen] */
    guint bytessaved;
    gint loaderror;
    gint buf = -1;

    loaderror = g_io_channel_read(loadfile,(gchar*)&buf,sizeof(guint),&bytessaved);
    /* read error? */
    if (loaderror != G_IO_ERROR_NONE) {
        switch (loaderror) {
            case G_IO_ERROR_NONE:    break;
            case G_IO_ERROR_AGAIN:   g_log(PIPER_BL_LOG_DOMAIN,G_LOG_LEVEL_ERROR,"Again error during parsing of savefile");
                                     break;
            case G_IO_ERROR_INVAL:   g_log(PIPER_BL_LOG_DOMAIN,G_LOG_LEVEL_ERROR,"Inval error during parsing of savefile");
                                     break;
            case G_IO_ERROR_UNKNOWN: g_log(PIPER_BL_LOG_DOMAIN,G_LOG_LEVEL_ERROR,"Unknown error during parsing of savefile");
                                     break;
            default:                 g_log(PIPER_BL_LOG_DOMAIN,G_LOG_LEVEL_ERROR,"Very unknown error during parsing of savefile, glib has new error messages, this code needs updating.");
                                     break;
        }
    }
    /* Nothing to read? */
    if (buf<0) {
        g_log(PIPER_BL_LOG_DOMAIN,G_LOG_LEVEL_ERROR,"Savefile is too short while reading %s, tried to read %i bytes but got nothing.",label,count);
    }
    /* read warning? */
    if (buf>count) {
        g_log(PIPER_BL_LOG_DOMAIN,G_LOG_LEVEL_WARNING,"Savefile is corrupt (read %i bytes, %i exspected) while reading %s, trying to recover.",buf,count,label);
    } else {
        count = buf;
    }

    /* read it ... */
    loaderror = g_io_channel_read(loadfile,data,count,&bytessaved);

    /* return number of bytes read */
    return bytessaved;
}

guint legacy::save_record(GIOChannel *savefile,gpointer data,gint count) {
    /* saves a record to the status file */
    guint bytessaved;
    gint saveerror;

    /* RecordLen [sizeof(gint):4] \ Data [RecordLen] */
    saveerror = g_io_channel_write(savefile,(gchar*)&count,sizeof(gint),&bytessaved);
    saveerror = g_io_channel_write(savefile,(gchar*)data,count,&bytessaved);
    return bytessaved;
}

void legacy::idle(glong delay) {
    /* sleep for {delay} microseconds */
    usleep(delay);
}

void legacy::BL_lock(const gchar *text) {
    /* TODO: use poll() */
    /* TODO: DB_LOCKED must be mutex */
    g_log(PIPER_BL_LOG_DOMAIN,G_LOG_LEVEL_DEBUG,"Engine locked (from %s)",text);
    if (DB_LOCKED) {
        g_log(PIPER_BL_LOG_DOMAIN,G_LOG_LEVEL_DEBUG,"Engine was already locked, waiting for unlock.");
        do idle(5);
        while (DB_LOCKED);
    }

    DB_LOCKED = TRUE;

    return;
}

void legacy::BL_unlock(const gchar *text) {
    /* Unlock engine */
    if (DB_LOCKED==FALSE) {
        g_log(PIPER_BL_LOG_DOMAIN,G_LOG_LEVEL_WARNING,"Unlocking non-locked BL (from %s)",text);
    } else {
        g_log(PIPER_BL_LOG_DOMAIN,G_LOG_LEVEL_DEBUG,"Engine unlocked (from %s)",text);
    }

    DB_LOCKED = FALSE;

    return;
}

void legacy::BL_locknunlock(const gchar *text) {
    /* used for functions that need to wait for previous locks,
       but dont need to have the DFP locked for themselfs */
    BL_lock(text);
    BL_unlock(text);
    return;
}

gboolean legacy::check_dl(void) {
    /* check if modules are supported on this platform */
    gint check;

    if (!g_module_supported ()) {
        g_log(PIPER_BL_LOG_DOMAIN,G_LOG_LEVEL_CRITICAL,"glib modules NOT supported on this platform, only Linux, Sun, HP-UX and Windows can handle this\nCheck www.gtk.org for more information\n");
        check = FALSE;
    } else
        check = TRUE;
    return check;
}

plugin_maker* legacy::load_plugin(gchar *fname,glong Node,gpointer Engine) {
    /* locates plugin, scans the functions and load the thing if all ok */
    GModule *plugin;
    GString *pluginpath;
    gchar *type;
    plugin_maker* RESULT = NULL;
    GString* plugin_name;

    /* Parse plugin name */
    plugin_name = g_string_new((gchar*)((gint)fname+10));
    plugin_name = g_string_erase(plugin_name,(plugin_name->len)-3,3);


    BL_lock("legacy::load_plugin");


    /* TODO : check init_configPanel and procedure too */
    type = (gchar*)g_malloc(16);
    /* FS location */
    pluginpath = g_string_new(PLUGIN_DIR);
    pluginpath = g_string_append(pluginpath,fname);
    /* check for visual OR sensor+collector pair plugin */
    memcpy(type,(void*)((gint)fname+10),6);
    memset((void*)((gint)type+6),0,1);
    /* check & load plugin */
    plugin = g_module_open(pluginpath->str,G_MODULE_BIND_MASK);


    if (!plugin) {
        g_log(PIPER_BL_LOG_DOMAIN,G_LOG_LEVEL_WARNING,"Unable to open plugin %s\n",g_module_error());
        RESULT = NULL;
    } else {
        g_log(PIPER_BL_LOG_DOMAIN,G_LOG_LEVEL_INFO,"Loading plugin %s... ",pluginpath->str);
        /* Set current plugin */
        // g_log(PIPER_BL_LOG_DOMAIN,G_LOG_LEVEL_INFO,"Plugin name = %s",plugin_name->str);
        /* Execute constructor */
        plugin_maker *constructor = (BL_plugins[plugin_name->str])();

        /* VISUALS: find init & destruct */
        if ( strcmp((gchar*)type,"visual")==0) {
            /* Set node procedure pointers to that of loaded plugin */
            //node_link_plugin(Node,Current_plugin);
        }
        /* SENSOR-COLLECTOR PAIRS: find init*2 & destruct*2 */
        if ( strcmp((gchar*)type,"sensor")==0) {
            /* Set node procedure pointers to that of loaded plugin */
            //node_link_plugin(Node,Current_plugin);
        }

        RESULT = constructor;
    }


    /* free'n exit */
    g_free(type);
    g_string_free(plugin_name,TRUE);
    g_string_free(pluginpath,TRUE);

    BL_unlock("legacy::load_plugin");

    return RESULT;
}

void log_handler(const gchar *log_domain,GLogLevelFlags log_level,const gchar *message,gpointer user_data) {
    /* Handles logging. See glib logging system for more info */
    time_t Time = time(NULL);
    GString *date;
    GString *domain;
    GString *level;
    gboolean quit;
    legacy* Legacy = (legacy*)user_data;

    /* Check log domain */
    if ((strcmp(log_domain,PIPER_BL_LOG_DOMAIN)!=0) && (strcmp(log_domain,PIPER_LOG_DOMAIN)!=0)) {
        g_error("Got a log for domain %s, which does not belong to the PIPER_LOG_DOMAIN.",log_domain);
    }
    /* Format domain */
    domain = g_string_new(log_domain);
    while (domain->len < 8) {
        domain = g_string_append(domain," ");
    }

    /* Handle log_level, strip flags */
    log_level = (GLogLevelFlags)(log_level & 252);
    switch (log_level) {
        case G_LOG_LEVEL_ERROR:      level = g_string_new("Error");
                                     quit = TRUE;
                                     break;
        case G_LOG_LEVEL_CRITICAL:   level = g_string_new("Critical");
                                     quit = TRUE;
                                     break;
        case G_LOG_LEVEL_WARNING:    level = g_string_new("Warning");
                                     quit = FALSE;
                                     break;
        case G_LOG_LEVEL_MESSAGE:    level = g_string_new("Message");
                                     quit = FALSE;
                                     break;
        case G_LOG_LEVEL_INFO:       level = g_string_new("Info");
                                     quit = FALSE;
                                     break;
        case G_LOG_LEVEL_DEBUG:      level = g_string_new("Debug");
                                     quit = FALSE;
                                     break;
        default:                     level = g_string_new("Unknown");
                                     quit = FALSE;
                                     break;
    }
    while (level->len < 8) {
        level =  g_string_append(level," ");
    }

    /* Format date string */
    date = g_string_new(ctime(&Time));
    date = g_string_truncate(date,(date->len)-1);
    
    /* Store log entry */
    /* TODO: - Write to file */
    g_print("%s | %i | %s | %s\n",date->str,linenr,level->str,message);
    linenr++;

    /* Should we exit the BL? */
    if (quit) {
         /* delete legacy, this will shutdown the BL */
         delete Legacy;
    }

    /* Free strings */
    g_string_free(date,TRUE);
    g_string_free(domain,TRUE);
    g_string_free(level,TRUE);

    return;
}

void log_handler_piper(const gchar *log_domain,GLogLevelFlags log_level,const gchar *message,gpointer user_data) {
    /* Handles Piper general log entries */

    /* TODO: route this messages to DL */
    log_handler(log_domain,log_level,message,user_data);

    return;
}

void log_handler_bl(const gchar *log_domain,GLogLevelFlags log_level,const gchar *message,gpointer user_data) {
    /* Handles Piper BL log entries */

    log_handler(log_domain,log_level,message,user_data);

    return;
}

//gboolean legacy::node_link_plugin(node* Node,BL_plugin* plugin) {
//    //TODO: implement
//    g_log(PIPER_BL_LOG_DOMAIN,G_LOG_LEVEL_WARNING,"legacy::node_link_plugin UNIMPLEMENTED");
//
//    return FALSE;
//}


