/*
 * Messaging Object 
 * this is the structure in which data resides inside the
 * messaging system, NO other structure will be used
 *
 * begin : 19-6-1999, BastardAI
 *          8-7-1999, Note Java-varinaming style
 *
 */
#include <glib.h>
#include "DFPADM.hh"
#include "messaging_node.h"

/*
 * VARIS
 */
glong currentNewNode = 1;
gboolean NODE_LOCKED_ID[65535];
gboolean NODE_LOCKED_LIST_INITIALISED = FALSE;
GHashTable* NODE_NAME_HASH;
GHashTable* NODE_FILTER_HASH;

/*
 * PROTOS...
 */
//none

/*
 * functions
 */
gchar* node::allowedFilter_to_char(GString *filter) {
	/* Fill string with filterstring */
	switch (filter->len) {
		case 0:		return((gchar*)"{Accept all}");break;
		default:	return((gchar*)filter->str);
	}
	return (gchar*)NULL;
}

gchar* node::status_to_char(statusType_t status) {
	/* fill string with status */
	switch (status) {
		case Passing:	return((gchar*)"Active");break;
		case Blocking:	return((gchar*)"Disabled");break;
		//removed, ??, case NonStream:	return((gchar*)"Special");break;
		default:		return((gchar*)"Unknown");
	}
	return (gchar*)NULL;
}

gchar* node::rtype_to_char(rType_t rot) {
	/* fill string with rtype */
	switch (rot) {
		case SameRT:					return((gchar*)"Same");break;
		case Undefined_StructRT:		return((gchar*)"Undefined");break;
		case Sequential_StructRT:		return((gchar*)"Sequential");break;
		case DualSequential_StructRT:	return((gchar*)"DualSequential");break;
		case ChainEnd_StructRT:			return((gchar*)"ChainEnd");break;
		default:						return((gchar*)"Undefined");
	}
	return (gchar*)NULL;
}

gchar* node::nodetype_to_char(nodeType_t nt)
{	/* fill string with nodetype */
	switch (nt) {
		case SensorNode:         return((gchar*)"Sensor");break;
		case PipeLineNode:       return((gchar*)"Pipeline");break;
		case CollectorNode:      return((gchar*)"Collector");break;
		case FilterNode:         return((gchar*)"Filter");break;
		case VisualNode:         return((gchar*)"Visual");break;
		case TemporaryNode:      return((gchar*)"Temporary");break;
                case UnknownNode:        return((gchar*)"Unknown");break;
		default:                 return((gchar*)"Not even Unknown? This is bad...");
	}
	return (gchar*)NULL;
}

