/* SWIG interface file for UiNode.cc */

%module UINode
%{
	#include "UINode.h"
	#include "UINetwork.h"
	#include "UITerminal.h"
	#include "UIDocument.h"
	#include "UILink.h"
	#include <tree.h>
%}

%typemap(python, out) vector<UITerminal *> {
	vector <UITerminal*> terms = *$source;
	PyObject *to_return = PyList_New(terms.size());
	
	for (int i=0; i < terms.size(); i++)
	{
		PyObject *new_item = SWIG_NewPointerObj((void *) terms[i],
										  SWIGTYPE_UITerminal_p);
										  
		PyList_SetItem(to_return, i, new_item);
	}
	$target = to_return;
}

class UINode {
  public:
   UINode(UINetwork* _net, string _name, string _type, double x, double y, 
		  bool doInit=1);
   
   virtual ~UINode();
   
   const string &getName();
   const string &getType();
   
   void setNodeParameters(UINodeParameters *params);

   virtual UINodeParameters *newNodeParameters (UINode *_node, string type);
   
   vector<UITerminal *> getInputs();
   vector <UITerminal *> getOutputs();
   UINodeParameters * getParameters();
   string getDescription();
   
   void getPos(double &xx, double &yy);
   void setPos(double new_x, double new_y);
   
};
