/* SWIG interface file for UINodeParameters.cc */

%module UINodeParameters
%{
	#include "UINodeParameters.h"
	#include "UINode.h"
	#include "UINetwork.h"
	#include "UIDocument.h"	
	#include <tree.h>
%}

class ParameterText {
  public:
	string name;
	string value;
	string type;
	string description;
}

%typemap(python, out) vector<ParameterText *> {
	vector <ParameterText *> params = *$source;
	PyObject *to_return = PyList_New(params.size());
	
	for (int i=0; i < params.size(); i++)
	{
		PyObject *new_item = SWIG_NewPointerObj((void *) params[i],
										  SWIGTYPE_ParameterText_p);
										  
		PyList_SetItem(to_return, i, new_item);
	}
	$target = to_return;
}

class UINodeParameters {
  public:
	UINodeParameters(UINode *_node, string type);
   	virtual ~UINodeParameters();
	
	ParameterText *addParameterText(string name, string value, string type);
	void removeParameterText(string nameToRemove);
	
	vector<ParameterText *> get_textParams();

};
