/* SWIG interface file for UITerminal.cc */

%module UITerminal 
%{
	#include "UITerminal.h"
	#include "UINode.h"
	#include "UILink.h"
	#include "UINetTerminal.h"
%}

class UITerminal {
  public:
	UITerminal (ItemInfo *terminalInfo, UINode *_node, bool _isInput, double _x, 
				double _y);
	virtual ~UITerminal();
	
	const string &getName();
	const string &getType();
	const string &getDescription();
	bool isInputTerminal();
	
	vector<UILink *> getConnections();
	UINode *getNode();
	
	void connectNetTerminal(UINetTerminal *term);
	void disconnectNetTerminal();
	
	void connect(UILink *link);
	void disconnect(UILink *link);
	bool isConnected();

};
