import gtk

from dialog import *

class PiedTerminalMenu:
	"""
	Builds the pop-up menu for the network which contains all of the
	options for things to do in Pied.
	"""
	def __init__(self):
		"""
		Initialize all of the possible nodes that are supported.
		"""
		pass


	def show(self, network, node):
		"""
		Create the menu and pop it up.
		"""
		dialog = PiedDialog()

		popup_menu = gtk.GtkMenu()
		popup_menu.set_title('title')
		ag = gtk.GtkAccelGroup()
		popup_menu.set_accel_group(ag)
		popup_menu.show()

		# Make submenu for Popup->Terminal
		submenu_1 = gtk.GtkMenu()
		submenu_1.show()

		# Make menu item Popup->Terminal->Details and append
		menu_item = gtk.GtkMenuItem('Details...')
		submenu_1.append(menu_item)
		menu_item.show()

		# Make menu item Popup->Terminal->Duplicate and append
		menu_item = gtk.GtkMenuItem('Disconnect')
		submenu_1.append(menu_item)
		menu_item.show()

		# Make menu item Popup->Terminal and append
		menu_item = gtk.GtkMenuItem('Terminal')
		menu_item.set_submenu(submenu_1)
		popup_menu.append(menu_item)
		menu_item.show()

		# Make submenu for Session
		submenu_2 = gtk.GtkMenu()
		submenu_2.show()

		# Make menu item Popup->Session->Quit and append
		menu_item = gtk.GtkMenuItem('Quit')
		menu_item.connect('activate', dialog.quit_dlg, network)
		submenu_2.append(menu_item)
		menu_item.show()

		# Make menu item Popup->Session and append
		menu_item = gtk.GtkMenuItem('Session')
		menu_item.set_submenu(submenu_2)
		popup_menu.append(menu_item)
		menu_item.show()

		# Make submenu for Help
		submenu_3 = gtk.GtkMenu()
		submenu_3.show()

		# Make menu item Popup->Help->About and append
		menu_item = gtk.GtkMenuItem('About')
		menu_item.connect('activate', dialog.about_dlg)
		submenu_3.append(menu_item)
		menu_item.show()		
		
		# Make menu item Popup->Help and append
		menu_item = gtk.GtkMenuItem('Help')
		menu_item.set_submenu(submenu_3)
		popup_menu.append(menu_item)
		menu_item.show()

		# Show popup menu
		popup_menu.popup(None, None, None, 3, 0)

