from gtk import *
from gnome.ui import *

class PiedWidget(GtkScrolledWindow):
	"""
	A widget inheriting from GtkScrolled Window that sets up a list--meant  
	to be used to view the contents of a widget. 
	"""	
	# get widget characteristics?
	get_type = GtkScrolledWindow().get_type()
	
	def __init__(self, list = None, isTest=0):
		"""
		You can initialize the wiget with two possible initial parameters.
		First, you can pass a list to initialize the widget with (list).
		If no list is passed, an empty list is created.
		You can also create a list with test data, by calling the widget
		as LociWidget(None, 1).
		"""
		# get an instance of the object?
		self._o = GtkScrolledWindow()._o
		
		# set a size
		self.width = 200
		self.height = 200
		
		##scrolling info
		self.set_usize(self.width, self.height)
		self.set_policy(POLICY_AUTOMATIC, POLICY_AUTOMATIC)
		
		# make a list to go in the Scrolling Window
		if (list == None):
			self.list = GtkCList(1, ["Container Contents",])
		else:
			self.list = list
		self.list.set_column_auto_resize(0,TRUE)
		self.list.set_column_justification(0,JUSTIFY_LEFT)
		self.list.set_column_justification(1,JUSTIFY_LEFT)
		self.list.set_column_auto_resize(1,TRUE)
		self.list.set_column_width(0,100)
		
		#add test data if the user wants it
		if (isTest == 1):
			self.list.append(["file1",])
			self.list.append(["file2",])
			self.list.append(["file3",])
		
		self.add(self.list)
		
		self.list.show()
		self.show()
		
		
