from gtk import *
from gnome.ui import *

class PiedWidget(GtkScrolledWindow):
	"""
	A widget inheriting from GtkScrolledWindow that displays items in a tree 
	format. This is meant for viewing the contents of a container which has 
	other containers in it (ie. a directory structure).
	"""
	# get widget chracteristics?
	get_type = GtkScrolledWindow().get_type()
	
	def __init__(self, tree = None, isTest=0):
		"""
		You can initialize the wiget with two possible initial parameters.
		First, you can pass a tree to initialize the widget with (tree).
		If no tree is passed, an empty tree is created.
		You can also create a tree with test data, by calling the widget
		as LociWidget(None, 1).
		"""
		
		# get an actual window object to play with??
		self._o = GtkScrolledWindow()._o
		
		# set up the size
		self.width = 200
		self.height = 200
		
		#scrolling info
		self.set_usize(self.width, self.height)
		self.set_policy(POLICY_AUTOMATIC, POLICY_AUTOMATIC)
		
		# make a tree to go in the Scrolling Window
		if (tree == None):
			self.tree = GtkCTree(1, 0, ["Container Contents",])
		else:
			self.tree = tree
		self.tree.set_column_auto_resize(0,TRUE)
		self.tree.set_column_justification(0,JUSTIFY_LEFT)
		self.tree.set_column_justification(1,JUSTIFY_LEFT)
		self.tree.set_column_auto_resize(1,TRUE)
		self.tree.set_column_width(0,100)
		
		# add test data if the user wants it
		if (isTest == 1):
			dir = self.tree.insert_node(None, None, ["Test_dir",], 5, None, None, None, None, FALSE, TRUE)
			file = self.tree.insert_node(dir, None, ["file1",], 5, None, None, None, None, TRUE, FALSE)
			file = self.tree.insert_node(dir, None, ["file2",], 5, None, None, None, None, TRUE, FALSE)
			file = self.tree.insert_node(None, None, ["file3",], 5, None, None, None, None, FALSE, TRUE)
		
		self.add(self.tree)
		
		self.tree.show()
		self.show()
		
		
		

		
		
		
