from gtk import *

# talking with the middle
from modules.middlecommunicate import *

# handling XML from the middle
from modules.handlemiddleresponse import *

class PiedWidget(GtkVBox):
	"""
	A widget to display the information in a database table. The widget is 
	set up as a GtkCList with multiple columns, with the field names as the 
	column names.
	"""
	
	get_type = GtkVBox(spacing=5).get_type()
	
	def __init__(self, locus, tableName, connectInfo):
		"""
		Create the initial widget containing table data. Three arguments
		must be passed:
			- locus: The locus the gui is located in. This is also
			  used to get the xml file for the locus.
			- tableName: The database table to get the information
			  from to fill the widget.
			- connectionInfo: A list of information needed to connect
			  to the database with the following elements:
				  0: database type (ie. MySQL, sybase, etc.)
				  1: host name
				  2: user name 
				  3: password (encrypted)
				  4: port
				  5: socket
		"""
		self._o = GtkVBox(spacing=5)._o
		
		self.width = 300
		self.height = 300
		
		# set up a frame to hold a label with info about the table
		self.frame = GtkFrame()
		
		# set up the scrolling window
		self.scrollWin = GtkScrolledWindow()
		self.scrollWin.set_policy(POLICY_AUTOMATIC, POLICY_AUTOMATIC)
		
		# create the initial list and add the columns
		self.tableList = GtkCList()
		self.tableList.column_titles_show()
			
		# set the label on the frame
		self.frame.set_label(':')	
			
		# add all of the internal elements to the widget
		self.frame.show()
		self.tableList.show()
		self.scrollWin.show()
	
		self.scrollWin.add(self.tableList)
		self.frame.add(self.scrollWin)
		self.add(self.frame)
		
		self.show()
