#!/usr/bin/env python

import sys
if sys.version[:3] == "1.4":
	import ni
	
import os
import getopt

# hack to include the configuration file in the PYTHONPATH
sys.path.insert(0, os.path.join(os.curdir, 'config'))

# configuration info for Piper
from piperconfig import *

# --- constants
HELP_STRING = '''\
Usage: piper [OPTION...] (for now, only one option at a time)

  --dl=STATE       Run (STATE=on) middle or not (STATE=off)
  --ui=TYPE        Gnome UI(TYPE=pied) or Text UI(TYPE=peep) or None(TYPE=none)
  --reloadplugins  Force a reload of all plugins
  -?, --help            Show this help message
  --version             Display version

Default: piper --dl=on --ui=<The UI selected in the configuration file>'''

# Gnome tries to parse the command-line, so we have to do it before we
# start Gnome

def LociMain(argv):

	# default
	start = 'yes'
	ui= default_ui
	pl = 'on'
	bl = 'on'
	dl = 'on'
	call_reload = 0

	# parse the arguments to see what we've got
	(options, arguments) = getopt.getopt(sys.argv[1:], 'v?', 
	  ['ui=', 'dl=', 'version', 'help', 'reloadplugins'])
	  
	#print options
	
	for option in options:
		if (option[0] == '--ui'):
			ui = option[1]
			
		elif (option[0] == '--dl'):
			dl = option[1]
			
		elif (option[0] == '-v') or (option[0] == '--version'):
			start = 'no'
			print loci_title, loci_version
			
		elif (option[0] == '-?') or (option[0] == '--help'):
			start = 'no'
			print HELP_STRING
			
		elif (option[0] == '--reloadplugins'):
			call_reload = 1
			
        # check for PL environment variables
        if not(os.environ.get('VFLOW_PATH')):
            print 'VFLOW_PATH enviroment variable not set, consult the Overflow documentation.'
            sys.exit(1)

        # clean old ior's
        os.system("rm ~/piper_info/ior/*")

	if start == 'yes':	
		#print 'dl:', dl
		#print 'ui:', ui

		# stupid hack. If they ask for both start two separate processes, one
		# for the dl and for the uil.
		#if (dl == 'on' and ui != 'none'):
		#	# start the dl
		#	if call_reload:
		#		os.system("./runpiper.py --dl=on --ui=none --reloadplugins &")
		#	else:
		#		os.system("./runpiper.py --dl=on --ui=none &")
		#	# start the specified ui
		#	os.system("./runpiper.py --dl=off --ui=" + ui + " &")
		#	# otherwise, start up the appropriate one
		#	else:
			if (pl == 'on'):
				print 'Starting processing layer...'
				os.system("PL &")
			if (bl == 'on'):
				print 'Starting brokering layer...'
				os.system("sleep 3")
				os.system("BL &")
			if dl == 'on':
				os.system("sleep 3");
				print 'Starting definition layer...'
				os.chdir(os.path.join(piper_dir, "dl"))
				if call_reload:
					os.system("./startdl.py --reloadplugins &")
				else:
					os.system("./startdl.py &")	
			if ui == 'pied':
				print 'Starting pied...'
				os.chdir(os.path.join(piper_dir, "uil", "pied"))
				os.execv("startpied.py", ["startpied.py"])
			if ui == 'peep':
				print 'Starting peep...'
				os.chdir(os.path.join(piper_dir, "uil", "peep"))
				os.execv("startpeep.py", ["startpeep.py"])
                        # Now do some serious cleaning up
                        # TODO: implement this

if __name__ == '__main__':

	LociMain(sys.argv)
